using System;
using System.Linq;
using System.Collections.Generic;

class Solution {
  public static void Main(string[] args) {
    int arrayCount = int.Parse(Console.ReadLine());
    var array = Console.ReadLine().Split(" ").Select(s => int.Parse(s)).ToArray();
    List<int[]> steps = new();
    steps.Add(array);
    for(int i = 0; i < arrayCount - 1; i++)
    {
        steps.Add(Console.ReadLine().Split(" ").Select(s => int.Parse(s)).ToArray());
    }
    
    List<int> vList = new();
    List<int> pList = new();

    bool v_notp = true;
    for(int i = 0; i < arrayCount; i++)
    {
        var current = steps[i];

        if(i == arrayCount - 1)
        {
            if(v_notp)
                vList.Add(current.Single());
            else
                pList.Add(current.Single());

            break;
        }
        var next = steps[i + 1];

        var number = GetRemainingNumber(current.ToList(), next.ToList());
        if(v_notp)
            vList.Add(number);
        else
            pList.Add(number);

        v_notp = !v_notp;
    }

    vList = vList.OrderBy(c => c).ToList();
    pList = pList.OrderBy(c => c).ToList();
    Console.WriteLine(string.Join(" ", vList));
    Console.WriteLine(string.Join(" ", pList));
  }

  public static int GetRemainingNumber(List<int> current, List<int> next)
  {
    foreach(var i in next)
    {
        current.Remove(i);
    }

    return current.Single();
  }
}
