#include <bits/stdc++.h>
using namespace std;

bool isInside(int x, int y) {
    if (x < 1 || x > 100 || y < 1 || y > 100)
        return false;
    cout << "? " << x << " " << y << endl;
    cout.flush();
    string ans;
    cin >> ans;
    return (ans == "inside");
}

void answer(bool result) {
    if (result) {
        cout << "! square" << endl;
    } else {
        cout << "! rectangle" << endl;
    }
    cout.flush();
    exit(0);
}

int main() {
    int originX = 0, originY = 0;
    
    while(!isInside(originX, originY))
    {
        originX = (std::rand()%100) + 1;
        originY = (std::rand()%100) + 1;
    }

    int maxX = originX, maxY = originY;
    const int increment = 10;

    while(isInside(maxX + increment, originY))
    {
        maxX+=increment;
    }
    while(isInside(maxX + 1, originY))
    {
        maxX++;
    }
    while(isInside(maxX, maxY + increment))
    {
        maxY+=increment;
    }
    while(isInside(maxX, maxY + 1))
    {
        maxY++;
    }

    int minX = originX, minY = originY;

    while(isInside(minX - increment, originY))
    {
        minX-=increment;
    }
    while(isInside(minX - 1, originY))
    {
        minX--;
    }
    while(isInside(minX, minY - increment))
    {
        minY-=increment;
    }
    while(isInside(minX, minY - 1))
    {
        minY--;
    }

    int dx = std::abs(minX - maxX);
    int dy = std::abs(minY - maxY);

    answer(dx == dy);
}