#include <bits/stdc++.h>
using namespace std;

bool isInside(int x, int y) {
    if (x < 1 || x > 100 || y < 1 || y > 100)
        return false;
    cout << "? " << x << " " << y << endl;
    cout.flush();
    string ans;
    cin >> ans;
    return (ans == "inside");
}

void answer(bool result) {
    if (result) {
        cout << "! square" << endl;
    } else {
        cout << "! rectangle" << endl;
    }
    cout.flush();
    exit(0);
}

int getX(int originFind, int originConst, bool x)
{
    return x ? originFind : originConst;
}
int getY(int originFind, int originConst, bool x)
{
    return x ? originConst : originFind;
}

int approach(int& originFind, int originConst, bool x, bool negative)
{
    int increments[] = 
    {
        20, 10, 5, 2, 1
    };

    for(int increment: increments)
    {
        //int increment = increments[i];

        while(
            isInside(
                getX(originFind + increment, originConst, x),
                getY(originFind + increment, originConst, x)))
        {
            if(!negative)
                originFind+=increment;
            else
                originFind-=increment;
        }
    }
}




int main() {
    int originX = 0, originY = 0;
    
    do
    {
        originX = (std::rand()%100) + 1;
        originY = (std::rand()%100) + 1;
    }
    while(!isInside(originX, originY));

    int maxX = originX, maxY = originY;
    approach(maxX, originY, true, false);
    approach(originX, maxY, false, false);

    int minX = originX, minY = originY;

    approach(minX, originY, true, true);
    approach(originX, minY, true, true);

    int dx = std::abs(minX - maxX);
    int dy = std::abs(minY - maxY);

    answer(dx == dy);
}