#include <bits/stdc++.h>
using namespace std;

bool isInside(int x, int y) {
    if (x < 1 || x > 100 || y < 1 || y > 100)
        return false;
    cout << "? " << x << " " << y << endl;
    cout.flush();
    string ans;
    cin >> ans;
    return (ans == "inside");
}

void answer(bool result) {
    if (result) {
        cout << "! square" << endl;
    } else {
        cout << "! rectangle" << endl;
    }
    cout.flush();
    exit(0);
}

int getX(int originFind, int originConst, bool x)
{
    return x ? originFind : originConst;
}
int getY(int originFind, int originConst, bool x)
{
    return x ? originConst : originFind;
}

int approach(int originFind, int originConst, bool x, bool negative)
{
    int increments[] = 
    {
        40, 20, 10, 2, 1
    };
    
    int multiplier = 1;
    if(negative) multiplier = -1;
    
    int barrier = -500;

    for(int increment: increments)
    {
        
            
        //bool exit = false;
        while(true)
        {
            if(originFind + increment * multiplier > 100 || originFind + increment * multiplier < 1) 
            break;
            
            if(negative && barrier != -500)
                if(barrier >= originFind + increment * multiplier) 
                    break;
                
            if(!negative && barrier != -500)
                if(barrier <= originFind + increment * multiplier)
                    break;
                    
            int xp = getX(originFind + increment * multiplier, originConst, x);
            int yp = getY(originFind + increment * multiplier, originConst, x);
            bool inside = isInside(xp, yp);
            
            if(inside)
            {
                originFind += increment * multiplier;
            }
            else
            {
                int newBarrier = x ? xp : yp;
                barrier = negative ? std::max(newBarrier, barrier) : std::min(newBarrier, barrier);
                
                if(barrier == -500) barrier = newBarrier;
                break;
            }
        }
    }

    return originFind;
}

vector<tuple<int, int>> getRandomOrigins(int everyX)
{
    vector<tuple<int, int>> v;
    int counter = 0;
    for(int y = 0; y < 21; y++)
    {
        for(int x = 0; x < 21; x++)
        {
            if(counter != everyX - 1)
            {
                counter++;
                continue;
            }
                counter = 0;
            
            int xp = std::min(x * 5 + 1, 100);
            int yp = std::min(y * 5 + 1, 100);
            
            v.push_back(tuple<int, int>(xp, yp));
        }
    }
    
    return v;
}


int main() {
    //std::srand(time(0));
    int originX, originY;
    vector<tuple<int, int>> r = getRandomOrigins(6);
    
    int randomRequests = 0;
    
    do
    {
        tuple<int, int> t = r.at(rand() % r.size());
        originX = std::get<0>(t);
        originY = std::get<1>(t);
        //cout << originX << " " << originY << endl;
        randomRequests++;
    }
    while(!isInside(originX, originY));

    int maxX = originX == 100 ? 100 : approach(originX, originY, true, false);
    int maxY = originY == 100 ? 100 : approach(originY, originX, false, false);

    int minX = originX == 1 ? 1 : approach(originX, originY, true, true);
    int minY = originY == 1 ? 1 : approach(originY, originX, false, true);

    int dx = std::abs(minX - maxX);
    int dy = std::abs(minY - maxY);

    answer(dx == dy);
}