#include <bits/stdc++.h>
using namespace std;

bool query(int x, int y)
{
    if (x <= 0 || x > 100 || y <= 0 || y > 100)
        return false;
    cout << "? " << x << " " << y << endl;
    cout.flush();
    string ans;
    cin >> ans;
    return (ans == "inside");
}

void answer(bool result)
{
    if (result)
    {
        cout << "! square" << endl;
    }
    else
    {
        cout << "! rectangle" << endl;
    }
    cout.flush();
    exit(0);
}

bool isSquare(int x1, int y1, int x2, int y2)
{
    int midx = (x1 + x2) / 2;
    int midy = (y1 + y2) / 2;

    if (x1 == x2 && y1 == y2)
    {
        return true;
    }
    else if (x1 == x2 || y1 == y2)
    {
        return false;
    }
    else
    {
        bool topLeft = query(midx, midy);
        bool topRight = query(midx + 1, midy);
        bool bottomLeft = query(midx, midy + 1);
        bool bottomRight = query(midx + 1, midy + 1);

        if (topLeft == topRight && topRight == bottomLeft && bottomLeft == bottomRight)
        {
            return isSquare(x1, y1, midx, midy);
        }
        else if (topLeft == topRight && topRight == bottomRight && bottomRight != bottomLeft)
        {
            return isSquare(x1, y1, midx, midy + 1);
        }
        else if (topLeft == topRight && topRight != bottomRight && bottomRight == bottomLeft)
        {
            return isSquare(x1, y1, midx + 1, midy);
        }
        else if (topLeft == bottomRight && bottomRight == bottomLeft && topRight != topLeft)
        {
            return isSquare(x1, y1, midx + 1, midy + 1);
        }
        else
        {
            return false;
        }
    }
}

int main()
{
    bool res = isSquare(1, 1, 100, 100);
    answer(res);
    return 0;
}