#include <bits/stdc++.h>
using namespace std;

bool query(int x, int y)
{
    if (x <= 0 || x > 100 || y <= 0 || y > 100)
        return false;
    cout << "? " << x << " " << y << endl;
    cout.flush();
    string ans;
    cin >> ans;
    return (ans == "inside");
}

void answer(bool result)
{
    if (result)
    {
        cout << "! square" << endl;
    }
    else
    {
        cout << "! rectangle" << endl;
    }
    cout.flush();
    exit(0);
}

pair<int, int> getLeftTop()
{
    int x = 1, y = 1, x_ = 100, y_ = 100;
    while (x < x_)
    {
        int xmid = (x + x_) / 2;
        if (query(xmid, y))
            x_ = xmid;
        else
            x = xmid + 1;
    }
    while (y < y_)
    {
        int ymid = (y + y_) / 2;
        if (query(x, ymid))
            y_ = ymid;
        else
            y = ymid + 1;
    }
    return {x, y};
}

pair<int, int> getRightBottom()
{
    int x = 1, y = 1, x_ = 100, y_ = 100;
    while (x < x_)
    {
        int xmid = (x + x_ + 1) / 2;
        if (query(xmid, y_))
            x = xmid;
        else
            x_ = xmid - 1;
    }
    while (y < y_)
    {
        int ymid = (y + y_ + 1) / 2;
        if (query(x_, ymid))
            y = ymid;
        else
            y_ = ymid - 1;
    }
    return {x_, y_};
}

int main()
{
    pair<int, int> leftTop = getLeftTop();
    pair<int, int> rightBottom = getRightBottom();

    if (leftTop.first + rightBottom.second == rightBottom.first + leftTop.second)
        answer(true);
    else
        answer(false);

    return 0;
}