#include <bits/stdc++.h>
using namespace std;

bool query(int x, int y)
{
    if (x <= 0 || x > 100 || y <= 0 || y > 100)
        return false;
    cout << "? " << x << " " << y << endl;
    cout.flush();
    string ans;
    cin >> ans;
    return (ans == "inside");
}

void answer(bool result)
{
    if (result)
    {
        cout << "! square" << endl;
    }
    else
    {
        cout << "! rectangle" << endl;
    }
    cout.flush();
    exit(0);
}

pair<int, int> findLeftTop()
{
    int left = 1, right = 100;
    while (left < right)
    {
        int mid = (left + right) / 2;
        if (query(mid, 1))
            right = mid;
        else
            left = mid + 1;
    }
    int x = left;
    left = 1, right = 100;
    while (left < right)
    {
        int mid = (left + right) / 2;
        if (query(1, mid))
            right = mid;
        else
            left = mid + 1;
    }
    int y = left;
    return {x, y};
}

pair<int, int> findRightBottom()
{
    int left = 1, right = 100;
    while (left < right)
    {
        int mid = (left + right) / 2;
        if (query(mid, 100))
            left = mid + 1;
        else
            right = mid;
    }
    int x = left - 1;
    left = 1, right = 100;
    while (left < right)
    {
        int mid = (left + right) / 2;
        if (query(100, mid))
            left = mid + 1;
        else
            right = mid;
    }
    int y = left - 1;
    return {x, y};
}

int main()
{
    pair<int, int> leftTop = findLeftTop();
    pair<int, int> rightBottom = findRightBottom();

    int width = rightBottom.first - leftTop.first;
    int height = rightBottom.second - leftTop.second;
    if (width == height)
        answer(true);
    else
        answer(false);
}