#include <bits/stdc++.h>
using namespace std;

bool query(int x, int y)
{
    if (x <= 0 || x > 100 || y <= 0 || y > 100)
        return false;
    cout << "? " << x << " " << y << endl;
    cout.flush();
    string ans;
    cin >> ans;
    return (ans == "inside");
}

void answer(bool result)
{
    if (result)
    {
        cout << "! square" << endl;
    }
    else
    {
        cout << "! rectangle" << endl;
    }
    cout.flush();
    exit(0);
}

pair<int, int> findLeftTop()
{
    int x_left = 1, x_right = 100, y_left = 1, y_right = 100;
    while (x_left < x_right || y_left < y_right)
    {
        int x_mid = (x_left + x_right) / 2;
        int y_mid = (y_left + y_right) / 2;
        if (query(x_mid, y_mid))
        {
            x_right = x_mid;
            y_right = y_mid;
        }
        else
        {
            x_left = x_mid + 1;
            y_left = y_mid + 1;
        }
    }

    return {x_left, y_left};
}

pair<int, int> findRightBottom()
{
    int x_left = 1, x_right = 100, y_left = 1, y_right = 100;
    while (x_left < x_right || y_left < y_right)
    {
        int x_mid = (x_left + x_right) / 2;
        int y_mid = (y_left + y_right) / 2;
        if (query(x_mid, y_mid))
        {
            x_left = x_mid + 1;
            y_left = y_mid + 1;
        }
        else
        {
            x_right = x_mid;
            y_right = y_mid;
        }
    }

    return {x_right, y_right};
}

int main()
{
    pair<int, int> leftTop = findLeftTop();
    pair<int, int> rightBottom = findRightBottom();

    int width = rightBottom.first - leftTop.first;
    int height = rightBottom.second - leftTop.second;
    if (width == height)
        answer(true);
    else
        answer(false);
}