#include <bits/stdc++.h>
#include <iostream>
using namespace std;


bool query(int x, int y) {
    if (x <= 0 || x > 100 || y <= 0 || y > 100)
        return false;
    cout << "? " << x << " " << y << endl;
    cout.flush();
    string ans;
    cin >> ans;
    return (ans == "inside");
}

void answer(bool result) {
    if (result) {
        cout << "! square" << endl;
    } else {
        cout << "! rectangle" << endl;
    }
    cout.flush();
    exit(0);
}


bool find1_xy(int& x, int& y, int n)
{
        int i=0, j=0;
        for(int cnt=0; cnt<2*n-1; cnt++)
        {
                if(cnt<n) {
                        i = cnt;
                        j = 0;
                }
                else {
                        i = n-1;
                        j = (cnt+1)%n;
                }
                while(i>=0 && j<n)
                {
                        if (query(i + 1, j + 1))
                        {
                                x = i;
                                y = j;
                                return true;
                        }
                        i--;
                        j++;
                }
        }
        return false;
}

bool find2_xy(int& x, int& y, int n)
{
        int i=0, j=0;
        for(int cnt=0; cnt<2*n-1; cnt++)
        {
                if(cnt<n) {
                        i = cnt;
                        j = 0;
                }
                else {
                        i = n-1;
                        j = (cnt+1)%n;
                }
                while(i>=0 && j<n)
                {
                        if (query(n - i, n - j))
                        {
                                x = i;
                                y = j;
                                return true;
                        }
                        i--;
                        j++;
                }
        }
        return false;
}

bool check_xy(int x, int y, bool expected)
{
    if (x <= 0 || x > 100 || y <= 0 || y > 100)
                return true;
        if (query(x, y) != expected)
                return false;
        return true;    
}


int main() {
        int x1, y1, x2, y2;
        if (find1_xy(x1, y1, 100))
        {
                if (!find2_xy(x2, y2, 100))
                {
                        answer(false);
                }
        }
        if (x1 != x2)
        {
                for(int x = x1; x <= x2; ++x)
                {
                        if (!check_xy(x, y1 - 1, false))
                        {
                                answer(false);
                        }
                        if (y2 != y1 && !check_xy(x, y1 + 1, true))
                        {
                                answer(false);
                        }

                        if (y2 != y1 && !check_xy(x, y2 - 1, true))
                        {
                                answer(false);
                        }
                        if (!check_xy(x, y2 + 1, false))
                        {
                                answer(false);
                        }
                }
        }

        if (y1 != y2)
        {
                for(int y = y1; y <= y2; ++y)
                {
                        if (!check_xy(x1, y - 1, false))
                        {
                                answer(false);
                        }
                        if (x2 != x1 && !check_xy(x1, y + 1, true))
                        {
                                answer(false);
                        }

                        if (x2 != x1 && !check_xy(x2, y - 1, true))
                        {
                                answer(false);
                        }
                        if (!check_xy(x2, y + 1, false))
                        {
                                answer(false);
                        }
                }
        }
        answer(true);
}
