#include <iostream>
#include <vector>
#include <algorithm>

#define int long long

using namespace std;

bool Search(vector<int> arr, int x, int n) {
    int l = 0;
    int r = n - 1;
    int mid;
    while (l <= r) {
        mid = (l + r) / 2;
        if (arr[mid] == x) {
            return true;
        } else if (arr[mid] > x) {
            r = mid - 1;
        } else if (arr[mid] < x) {
            l = mid + 1;
        }
    }
    return false;
}

signed main() {
    int n;
    cin >> n;
    int x;
    vector<int> arr(n);
    vector<int> Vasyl;
    vector<int> Petro;
    vector<int> New;
    for (int i = 0; i < n; ++i) {
        cin >> arr[i];
    }
    sort(arr.begin(), arr.end());
    for (int i = 0; i < n - 1; ++i) {
        for (int j = 0; j < n - i - 1; ++j) {
            cin >> x;
            New.push_back(x);
        }
        for (int j = 0; j < n; ++j) {
            if(!Search(New, arr[j], n - i - 1)) {
                if (i % 2 == 0)
                    Vasyl.push_back(arr[j]);
                if(i % 2 == 1)
                    Petro.push_back(arr[j]);
                vector<int>::iterator position = find(arr.begin(), arr.end(), arr[j]);
                arr.erase(position);
            }
        }
        New.clear();
    }
    sort(Vasyl.begin(), Vasyl.end());
    sort(Petro.begin(), Petro.end());
    for (auto element: Vasyl) {
        cout << element << ' ';
    }
    cout << endl;
    for (auto it: Petro) {
        cout << it << ' ';
    }
}
