#include <bits/stdc++.h>

using namespace std;

map<long long, long long> a[1001][1001];
bool av[1001][1001];

map<long long, long long> out(long long x)
{
    map<long long, long long> ans;

    if(x==1)
    {
        ans.insert(make_pair(1, 1));

        return ans;
    }

    long long cn=2, cc=0;

    while(x>1)
    {
        if(x%cn==0)
        {
            x/=cn;
            cc++;
        }
        else
        {
            if(cc!=0)
                ans.insert(make_pair(cn, cc));

            cc=0;
            cn++;
        }
    }

    if(cc!=0)
        ans.insert(make_pair(cn, cc));

    return ans;
}

map<long long, long long> mult(map<long long, long long> m1, map<long long, long long> m2)
{
    map<long long, long long> ans;

    for(auto it=m1.begin(); it!=m1.end(); it++)
    {
        auto ins=(*it);
        auto it2=m2.find(ins.first);

        if(it2!=m2.end())
        {
            ins.second+=(*it2).second;
            m2.erase(it2);
        }

        if(ins.second!=0)
            ans.insert(ins);
    }

    for(auto it=m2.begin(); it!=m2.end(); it++)
    {
        auto ins=(*it);

        if(ins.second!=0)
            ans.insert(ins);
    }

    return ans;
}

map<long long, long long> divide(map<long long, long long> m1, map<long long, long long> m2)
{
    map<long long, long long> tmp;

    for(auto it=m2.begin(); it!=m2.end(); it++)
    {
        auto ins=(*it);

        ins.second*=-1;

        tmp.insert(ins);
    }

    return mult(m1, tmp);
}

map<long long, long long> val_1(long long x, long long y)
{
    if(av[x][y])
        return a[x][y];

    av[x][y]=1;

    auto pr=divide(val_1(x-1, y), val_1(x-1, y+1));

    a[x][y]=mult(val_1(x, y+1), pr);

    return a[x][y];
}

map<long long, long long> val_2(long long x, long long y)
{
    if(av[x][y])
        return a[x][y];

    av[x][y]=1;

    auto pr=divide(val_2(x+1, y), val_2(x+1, y-1));

    a[x][y]=mult(val_2(x, y-1), pr);

    return a[x][y];
}

int main()
{
    long long n;

    cin>>n;

    for(int i=0; i<n; i++)
    {
        long long x;
        cin>>x;

        a[i][i]=out(x);
        av[i][i]=1;
    }

    for(int i=0; i<n-1; i++)
    {
        long long x;
        cin>>x;

        a[i][i+1]=out(x);
        av[i][i+1]=1;
    }

    long long p, q;

    cin>>p>>q;

    p--;
    q--;

    if(p<q)
    {
        auto ans=val_1(q, p);
        int ss=0;

        for(auto it=ans.begin(); it!=ans.end(); it++)
        {
            if((*it).first!=1)
            {
                cout<<(*it).first<<" "<<(*it).second<<"\n";
                ss++;
            }
        }

        if(ss==0)
            cout<<"1 1\n";
    }
    else
    {
        auto ans=val_2(q, p);
        int ss=0;

        for(auto it=ans.begin(); it!=ans.end(); it++)
        {
            if((*it).first!=1)
            {
                cout<<(*it).first<<" "<<(*it).second<<"\n";
                ss++;
            }
        }

        if(ss==0)
            cout<<"1 1\n";
    }

    return 0;
}
