#include <bits/stdc++.h>
using namespace std;

bool query(int x, int y) {
    if (x <= 0 || x > 100 || y <= 0 || y > 100)
        return false;
    cout << "? " << x << " " << y << endl;
    cout.flush();
    string ans;
    cin >> ans;
    return (ans == "inside");
}

void answer(bool result) {
    if (result) {
        cout << "! square" << endl;
    } else {
        cout << "! rectangle" << endl;
    }
    cout.flush();
    exit(0);
}

int main() {
    int x = 1;
    int y = 1;
    int step = 4;
    bool isPlus = true;
    while(!query(x, y)) {
        x += step;
        if(x >= 100) {
            y += step;
            if(y >= 100) {
                break;
            }
            x = 0;
        }
    }

    while(x > 1 && query(x, y)) {
        x--;
    }
    x++;
    while(y > 1 && query(x, y)) {
        y--;
    }
    y++;
    
    for(int i = 0; (x + i) <= 100 && (y + i) <= 100; i++) {
        bool q1 = query(x, y + i);
        bool q2 = query(y, x + i);
        if(!q1) {
            if(q2) {
                answer(false);
                return 0;
            }
            answer(true);
            return 0;
        }else if(!q2) {
            if(q1) {
                answer(false);
                return 0;
            }
            answer(true);
            return 0;
        }
    }

    if(x == 101) {
        if(y == 101) {
            answer(true);
            return 0;
        }else if(query(100, y)) {
            answer(false);
            return 0;
        }
    }
    else if(y == 101) {
        if(x == 101) {
            answer(true);
            return 0;
        }else if(query(x, 100)) {
            answer(false);
            return 0;
        }
    }

    answer(true);
}