#include <bits/stdc++.h>
using namespace std;

bool known_outside[100][100]{ false };

bool inside(int x, int y) 
{
    if (x <= 0 || x > 100 || y <= 0 || y > 100)
    {
        return false;
    }
    if (known_outside[x - 1][y - 1])
    {
        return false;
    }

    cout << "? " << x << " " << y << endl;
    string ans;
    cin >> ans;

    bool result = (ans[0] == 'i');
    if (!result)
    {
        known_outside[x - 1][y - 1] = true;
    }
    return result;
}

void answer(bool result) 
{
    if (result) 
    {
        cout << "! square" << endl;
    }
    else 
    {
        cout << "! rectangle" << endl;
    }
    exit(0);
}

int random(int lowest, int highest)
{
    return rand() % (highest - lowest + 1) + lowest;
}

int main()
{
    int x = 50;
    int y = 50;
    while(!inside(x, y))
    {
        x = random(1, 100);
        y = random(1, 100);
    }

    int left_side = x;
    int right_side = x;
    int upper_side = y;
    int lower_side = y;

    bool incrementing = false;
    int going_to_bound = 1;
    int going_from_bound = left_side;
    while (abs(going_to_bound - going_from_bound) != 1)
    {
        left_side = (left_side + going_to_bound + incrementing) / 2;
        if (inside(left_side, upper_side) != incrementing)
        {
            going_from_bound = left_side;
            continue;
        }
        else
        {
            going_to_bound = going_from_bound;
            going_from_bound = left_side;
            incrementing = !incrementing;
        }
    }

    incrementing = false;
    going_to_bound = 1;
    going_from_bound = upper_side;
    while (abs(going_to_bound - going_from_bound) != 1)
    {
        upper_side = (upper_side + going_to_bound + incrementing) / 2;
        if (inside(left_side, upper_side) != incrementing)
        {
            going_from_bound = upper_side;
            continue;
        }
        else
        {
            going_to_bound = going_from_bound;
            going_from_bound = upper_side;
            incrementing = !incrementing;
        }
    }

    incrementing = true;
    going_to_bound = 100;
    going_from_bound = right_side;
    while (abs(going_to_bound - going_from_bound) != 1)
    {
        right_side = (right_side + going_to_bound + incrementing) / 2;
        if (inside(right_side, lower_side) == incrementing)
        {
            going_from_bound = right_side;
            continue;
        }
        else
        {
            going_to_bound = going_from_bound;
            going_from_bound = right_side;
            incrementing = !incrementing;
        }
    }

    incrementing = true;
    going_to_bound = 100;
    going_from_bound = lower_side;
    while (abs(going_to_bound - going_from_bound) != 1)
    {
        lower_side = (lower_side + going_to_bound + incrementing) / 2;
        if (inside(right_side, lower_side) == incrementing)
        {
            going_from_bound = lower_side;
            continue;
        }
        else
        {
            going_to_bound = going_from_bound;
            going_from_bound = lower_side;
            incrementing = !incrementing;
        }
    }

    answer((right_side - left_side) == (lower_side - upper_side));
}