#include <iostream>
#include <algorithm>
#include <vector>

int main() {
    int n;
    std::cin >> n;

    std::vector<int> prev;
    std::vector<int> cur;

    std::vector<int> vasyl;
    std::vector<int> petro;

    for (int i = 0; i < n; i++) {
        int x;
        std::cin >> x;
        prev.push_back(x);
    }

    for (int i = 0; i < n - 1; i++) {
        cur.clear();
        for (int j = 0; j < n; j++) {
            int x;
            std::cin >> x;
            cur.push_back(x);
        }

        for (int x : cur) {
            prev.erase(std::remove(prev.begin(), prev.end(), x), prev.end());
        }

        int missing = std::accumulate(prev.begin(), prev.end(), 0);

        if (i % 2 == 0) {
            vasyl.push_back(missing);
        } else {
            petro.push_back(missing);
        }

        prev = cur;
        if (prev.size() == 1) {
            if (i % 2 != 0) {
                vasyl.push_back(prev[0]);
            } else {
                petro.push_back(prev[0]);
            }
        }
    }

    std::sort(vasyl.begin(), vasyl.end());
    for (int x : vasyl) {
        std::cout << x << " ";
    }
    std::cout << std::endl;

    std::sort(petro.begin(), petro.end());
    for (int x : petro) {
        std::cout << x << " ";
    }

    return 0;
}
