#include <iostream>
#include <set>
#include <vector>
#include <climits>
#include <string>
#include <algorithm>
#include <cmath>
#include <map>

using namespace std;

typedef long long ll;
typedef long long ull;
typedef pair<int, int> pint;
typedef pair<ll, ll> pll;

int m1, m2;
int anst = 0;
bool ever1 = false, ever2 = false;
string res = "They can not do it!";
vector<int> v;

void Dive(vector<int> v1, vector<int> v2, int lm1, int lm2, int i)
{
    if (i == 5)
    {
        int anstype = 0;
        string nextans = "They both can do it!";
        if ((v1.size() != 0) && (v2.size() != 0))
        {
            anstype = 1;
            nextans = "They need to work together!\nVasyl:";
            for (int i = 0; i < v1.size(); i++)
            {
                nextans += " " + to_string(v1[i] + 1);
            }
            nextans += "\nPetro:";
            for (int i = 0; i < v2.size(); i++)
            {
                nextans += " " + to_string(v2[i] + 1);
            }
        }
        else if (v1.size() == 5)
        {
            ever1 = true;
            anstype = 2;
            nextans = "Vasyl can do it!";
        }
        else if (v2.size() == 5)
        {
            ever2 = true;
            anstype = 2;
            nextans = "Petro can do it!";
        }
        if (anstype > anst)
        {
            anst = anstype;
            res = nextans;
        }
        if (ever1 && ever2)
        {
            anst = 3;
            res = "They both can do it!";
        }
        return;
    }
    vector<int> nv1 = v1;
    vector<int> nv2 = v2;
    if (lm1 >= v[i])
    {
        nv1.push_back(i);
        Dive(nv1, v2, lm1 - v[i], lm2, i + 1);
    }
    if (lm2 >= v[i])
    {
        nv2.push_back(i);
        Dive(v1, nv2, lm1, lm2 - v[i], i + 1);
    }
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    for (int i = 0; i < 5; i++)
    {
        int inp; cin >> inp;
        v.push_back(inp);
    }
    cin >> m1 >> m2;
    Dive(vector<int>(), vector<int>(), m1, m2, 0);
    cout << res << "\n";
}