#include <bits/stdc++.h>
using namespace std;
using ll = unsigned long long;

vector<pair<ll, int>> f(vector<pair<ll, int>> a, vector<pair<ll, int>> b, vector<pair<ll, int>> c){
    map<ll, int> pr;
    for (auto i: a){
        pr[i.first] += i.second;
    }
    for (auto i: b){
        pr[i.first] += i.second;
    }
    for (auto i: c){
        pr[i.first] -= i.second;
    }
    vector<pair<ll, int>> ans;
    for (auto i: pr){
        if (i.second == 0){
            continue;
        }
        ans.push_back({i.first, i.second});
    }
    return ans;
}

vector<pair<ll, int>> fact(ll x){
    vector<pair<ll, int>> ans;
    for (int i = 2; i*i <= x; i++){
        int cnt = 0;
        while (x % i == 0){
            cnt++;
            x /= i;
        }
        if (cnt > 0){
            ans.push_back({i, cnt});
        }
    }
    if (x > 1){
        ans.push_back({x, 1});
    }
    return ans;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

	int n, p, q; cin>>n;
    vector<pair<ll, int>> dp[n][n];
    ll x;
    for (int i = 0; i < n; i++){
        cin>>x;
        dp[n - i - 1][i] = fact(x);
    }
    for (int i = 0; i + 1 < n; i++){
        cin>>x;
        dp[n - i - 1][i + 1] = fact(x);
    }
    cin>>p>>q;
    for (int i = 0; i < 1; i++){
        int k = n - i - 2;
        for (int j = 0; j + i + 1 < n; j++){
            if (k < 0){
                break;
            }
            dp[k][j] = f(dp[k + 1][j], dp[k][j + 1], dp[k + 1][j + 1]);
            k--;
        }
    }
    for (int i = 0; i < 1; i++){
        int k = n - 1;
        for (int j = i + 2; j < n; j++){
            if (k <= 0){
                break;
            }
            dp[k][j] = f(dp[k - 1][j], dp[k][j - 1], dp[k - 1][j - 1]);
            k--;
        }
    }
    
    vector<pair<ll, int>> ans = dp[n - q][p - 1];
    if (ans.empty()){
        cout<<"1 1";
        return 0;
    }
    for (auto i: ans){
        cout<<i.first<<" "<<i.second<<endl;
    }
}