#include"bits/stdc++.h"
using namespace std;

#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2,bmi,bmi2,abm,popcnt")

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#define all(x) begin(x),end(x)

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

// #libs:libs

bool onLocal(){
    #ifdef LIS05ST
        return 1;
    #endif
    return 0;
}

void precalc(){

}

vector<pair<int,int>>buff;
void fact(int n){
    buff.clear();
    for(int i=2;i*i<=n;i++){
        if(n%i!=0)continue;
        int cnt=0;
        while(n%i==0)n/=i,cnt++;
        buff.push_back({i,cnt});
    }
    if(n!=1)buff.push_back({n,1});
}

map<int,int>pr;
void div(){
    for(auto [a,b]:buff)pr[a]-=b;
}
void mul(){
    for(auto [a,b]:buff)pr[a]+=b;
}

#define MULTITESTS 0
void solve(int testCase){
    int n;
    cin>>n;
    int a[n],b[n-1];
    for(auto&e:a)cin>>e;
    for(auto&e:b)cin>>e;
    int x,y;
    cin>>x>>y;
    x--,y--;


    // x
    for(int i=0;i+1<=x;i++){
        fact(a[i]);
        div();
        fact(b[i]);
        mul();
    }



    // y
    for(int i=0;i+1<=y;i++){
        fact(b[i]);
        div();
        fact(a[i+1]);
        mul();
    }

    fact(a[0]);
    mul();
    vector<pair<int,int>>vec;
    for(auto [a,b]:pr){
        if(b!=0)vec.push_back({a,b});
    }
    if(vec.empty()){
        cout<<"1 1\n";
        return;
    }
    sort(all(vec));
    for(auto [x,y]:vec)cout<<x<<" "<<y<<"\n";
}

const char* INPUT_FILE="/home/lis05st/CPv2/files/input.txt";
const char* OUTPUT_FILE="/home/lis05st/CPv2/files/output.txt";

signed main(){
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);

    if(onLocal()){
        freopen(INPUT_FILE,"r",stdin);
        freopen(OUTPUT_FILE,"w",stdout);

        time_t end_time=
        chrono::system_clock::to_time_t(chrono::system_clock::now());
    
        cout<<"Ran on "<<std::ctime(&end_time);
        cout<<"==================================\n";
    }

    precalc();
    int t=1;
    if(MULTITESTS)cin>>t;
    for(int i=1;i<=t;i++){
        auto t1=clock();
        solve(i);
        auto t2=clock();
        float delta=t2-t1;
        delta/=CLOCKS_PER_SEC;
        if(onLocal()){
            cout<<"("<<i<<")------------"<<fixed<<setprecision(2)<<delta<<"s\n";
        }
    }
}



