#include"bits/stdc++.h"
using namespace std;

#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2,bmi,bmi2,abm,popcnt")

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#define all(x) begin(x),end(x)

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

// #libs:libs

bool onLocal(){
    #ifdef LIS05ST
        return 1;
    #endif
    return 0;
}

void precalc(){

}

int XTEST1=20;int XTEST2=80;
int YTEST1=20;int YTEST2=80;
int COUNT=0;
bool queryTEST(int x,int y){
    if (x <= 0 || x > 100 || y <= 0 || y > 100)
        return false;
    cout << "? " << x << " " << y << endl;
    COUNT++;
    cout.flush();
    string ans="outside";
    if(XTEST1<=x&&x<=XTEST2){
        if(YTEST1<=y&&y<=YTEST2)ans="inside";
    }
    cout<<ans<<endl;
    return (ans == "inside");
}

bool query(int x, int y) {
    if (x <= 0 || x > 100 || y <= 0 || y > 100)
        return false;
    cout << "? " << x << " " << y << endl;
    cout.flush();
    string ans;
    cin >> ans;
    return (ans == "inside");
}

void answer(bool result) {
    if (result) {
        cout << "! square" << endl;
    } else {
        cout << "! rectangle" << endl;
    }
    cout.flush();
    exit(0);
}

#ifndef LIS05ST
    #define queryTEST query
#endif

#define MULTITESTS 0
void solve(int testCase){
    vector<pair<int,int>>pos;
    int start=10;
    for(int y=start;y<=100;y+=20)
    for(int x=start;x<=100;x+=20)pos.push_back({y,x});
    shuffle(all(pos),rng);

    int Y=-1,X=-1;
    for(auto [y,x]:pos){
        if(queryTEST(x,y)){
            Y=y;X=x;
            break;
        }
    }
    if(Y==-1){
        // rect
        answer(0);
        return;
    }
    int Xleft=X;int Xright=X;

    int L=-1;int R=X;
    while(R>L+1){
        int m=(L+R)/2;
        if(queryTEST(m,Y))R=m;
        else L=m;
    }
    Xleft=R;
    
    L=X;R=101;
    while(R>L+1){
        int m=(L+R)/2;
        if(queryTEST(m,Y))L=m;
        else R=m;
    }
    Xright=L;

    //cout<<X<<" "<<Y<<"\n";
    //cout<<Xleft<<" "<<Xright<<"\n";

    int Yleft=Y;int Yright=Y;

    if(Y<100-Y){

        L=-1;R=Y;
        while(R>L+1){
            int m=(L+R)/2;
            if(queryTEST(X,m))R=m;
            else L=m;
        }
        Yleft=R;
        
        int dist=Xright-Xleft;
        if(queryTEST(X,Yleft+dist)){
            if(!queryTEST(X,Yleft+dist+1))answer(1);
        }
    }else{
        L=Y;R=101;
        while(R>L+1){
            int m=(L+R)/2;
            if(queryTEST(X,m))L=m;
            else R=m;
        }
        Yright=L;
        int dist=Xright-Xleft;
        if(queryTEST(X,Yright-dist)){
            if(!queryTEST(X,Yright-dist-1))answer(1);
        }
    }
    answer(0);

    /*int distLeft=X-Xleft;int distRight=Xright-X;
    
    // check if it may be square
    if(distLeft==0||queryTEST(X,Y-distLeft)){
        if(distRight==0||queryTEST(X,Y+distRight)){

            // check if it is not rect
            if(queryTEST(X,Y-distLeft-1)||queryTEST(X,Y+distRight+1)){
                answer(0);
            }

            // it is a square!
            answer(1);
        }
    }*/
    answer(0);
}

const char* INPUT_FILE="/home/lis05st/CPv2/files/input.txt";
const char* OUTPUT_FILE="/home/lis05st/CPv2/files/output.txt";

signed main(){
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);

    if(onLocal()){
        freopen(INPUT_FILE,"r",stdin);
        freopen(OUTPUT_FILE,"w",stdout);

        time_t end_time=
        chrono::system_clock::to_time_t(chrono::system_clock::now());
    
        cout<<"Ran on "<<std::ctime(&end_time);
        cout<<"==================================\n";
    }

    precalc();
    int t=1;
    if(MULTITESTS)cin>>t;
    for(int i=1;i<=t;i++){
        auto t1=clock();
        solve(i);
        auto t2=clock();
        float delta=t2-t1;
        delta/=CLOCKS_PER_SEC;
        if(onLocal()){
            cout<<"("<<i<<")------------"<<fixed<<setprecision(2)<<delta<<"s\n";
        }
    }
}



