import sys

def query(x, y):
    print("?", x, y)
    sys.stdout.flush()
    return input().strip() == "inside"

def answer(result: bool):
    if result:
        print('! square')
    else:
        print('! rectangle')
    sys.stdout.flush()

x1, y1, x2, y2 = 1, 1, 100, 100
while x1 < x2 and y1 < y2:
    x_middle = (x1 + x2) // 2
    y_middle = (y1 + y2) // 2
    if query(x1, y_middle) == False and query(x2, y_middle) == False:
        answer(False)
        break
    elif query(x_middle, y1) == False and query(x_middle, y2) == False:
        answer(False)
        break
    elif query(x_middle, y_middle):
        x1, y1, x2, y2 = x_middle, y_middle, x2, y2
    else:
        x1, y1, x2, y2 = x1, y1, x_middle, y_middle
else:
    if x1 == x2 or y1 == y2:
        answer(False)
    else:
        answer(True)
