import sys

import math

# Function to check if a point is inside the painted area
def check_point(x, y):
    print("?", x, y)
    sys.stdout.flush()
    return input().strip() == "inside"

# Function to check if a rectangle is a square
def is_square(x1, y1, x2, y2):
    return (x2 - x1 + 1) == (y2 - y1 + 1)

# Initialize the corners of the painted area
x1, y1, x2, y2 = 1, 1, 100, 100

# Find the corners of the painted area
while True:
    x_middle = (x1 + x2) // 2
    y_middle = (y1 + y2) // 2
    if is_square(x1, y_middle, x2, y_middle) or is_square(x_middle, y1, x_middle, y2):
        print("! square")
        break
    if check_point(x_middle, y_middle) == "inside":
        x1, y1, x2, y2 = x_middle, y_middle, x2, y2
    else:
        x1, y1, x2, y2 = x1, y1, x_middle, y_middle
else:
    print("! rectangle")