import sys

import math

# Function to check if a point is inside the painted area
def check_point(x, y):
    print("?", x, y)
    sys.stdout.flush()
    return input() == "inside"

# Function to check if a rectangle is a square
def is_square(x1, y1, x2, y2):
    return (x2 - x1 + 1) == (y2 - y1 + 1)

# Initialize the corners of the painted area
x1, y1, x2, y2 = 1, 1, 100, 100

# Find the corners of the painted area
while not check_point(x1, y1):
    if x1 < x2:
        x1 += 1
    elif y1 < y2:
        x1 = 1
        y1 += 1
    else:
        break

while not check_point(x2, y2):
    if x2 > x1:
        x2 -= 1
    elif y2 > y1:
        x2 = 100
        y2 -= 1
    else:
        break

# Check if the painted area is a square
if is_square(x1, y1, x2, y2):
    print("! square")
else:
    print("! rectangle")
