#include <bits/stdc++.h>

#define pb push_back
#define sc second
#define fr first

using namespace std;
typedef long long ll;
typedef string str;
typedef pair<ll, ll> pll;
const ll MAXNUM = 1007;

struct Num{
    ll nom, denom;
    Num(){
        nom=0;
        denom=0;
    }

    Num(ll n1, ll d1){
        ll gcd = __gcd(n1, d1);
        nom = n1/gcd;
        denom = d1/gcd;
    }
};

ll n, m, k, p, q;
Num pole[MAXNUM][MAXNUM];

Num countCell(ll x,ll y){
    if(pole[x][y].denom!=0) return pole[x][y];
    else{
        Num p1, p2, p3;
        if(x>y){
            p1 = countCell(x-1, y); p2 = countCell(x, y+1); p3 = countCell(x-1, y+1);
        }
        else{
            p1 = countCell(x+1, y); p2 = countCell(x, y-1); p3 = countCell(x+1, y-1);
        }
        pole[x][y] = Num(p1.nom*p2.nom*p3.denom, p1.denom*p2.denom*p3.nom);
        return pole[x][y];
    }
}

vector<ll> prime;
vector<pll> result;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

	cin>>n;
    for(int i=1; i<=n; i++){
        cin >> m;
        pole[i][i] = Num(m, 1);
    }
    for(int i=1; i<n; i++){
        cin >> m;
        pole[i+1][i] = Num(m, 1);
    }
    cin >> p >> q;
    Num res = countCell(p, q);
    //cout << res.nom << ' ' << res.denom;
    if(res.nom==1 && res.denom==1) {cout << "1 1"; return 0;}
    prime.pb(2);
    ll ma = max(res.nom, res.denom);
    ll prm;
    for(int i=3; i<=ma; i++){
        prm=1;
        for(auto pr : prime){
            if(pr*pr>i) break;
            if(i%pr==0){prm = 0; break;}
        }
        if(prm) prime.pb(i);
    }
    for(auto pr : prime){
        //cout << pr << "\n";
        pll currpr = {pr, 0};
        if(res.nom%pr==0){
            while(res.nom%pr==0) {res.nom/=pr; currpr.sc++;}
            result.pb(currpr);
        }
        else if(res.denom%pr==0){
            while(res.denom%pr==0) {res.denom/=pr; currpr.sc--;}
            result.pb(currpr);
        }
    }
    for(auto div : result){
        cout << div.fr << ' ' << div.sc << "\n";
    }
}
