#include <bits/stdc++.h>

const int N = 2e5, M = 1e3;

using namespace std;
typedef long long ll;
typedef pair<int, int> pi;

vector<int> simp;

class num{
    public: 
    map<int, int> m;
    num(int v, int d = 1){
        v /= gcd(v, d);
        d /= gcd(v, d);
        multiply(v);
        divide(d);
    }
    void multiply(num &other){
        for(auto [i, j]: other.m)
            if(j)
                m[i] += j;
    }
    void multiply(int v){
        for(int i = 0; i < simp.size() && v != 1; ++i)
            while(v % simp[i] == 0){
                ++m[simp[i]];
                v /= simp[i];
            }
        if(v != 1)
            ++m[v];
    }
    void divide(int v){
        for(int i = 0; i < simp.size() && v != 1; ++i)
            while(v % simp[i] == 0)
                v /= simp[i],
                --m[simp[i]];
        if(v != 1)
            --m[v];
    }
    void out(){
        int n = m.size();
        for(auto [i, j]: m)
            n -= j == 0;
        if(!n){
            cout << "1 1\n";
            return;
        }
        for(auto [i, j]: m)
            if(j)
                cout << i << ' ' << j << '\n';
    }
};

void pre(){
    bool ch[((int) 4e4)]{};
    for(int i = 2, sq = sqrt(1e9); i <= sq; ++i){
        if(ch[i]) continue;
        simp.push_back(i);
        for(int j = i * 2; j < sq; j += i)
            ch[i] = 1;
    }
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    pre();
    int n, p, q;
    ll a[M], b[M];
    cin >> n;
    for(int i = 0; i < n; ++i)
        cin >> a[i];
    for(int j = 0; j < n - 1; ++j)
        cin >> b[j];
    cin >> p >> q; --p; --q;
    num r(1), c(1), pn(1), qn(1);
    for(int i = 0; i < n - 1; ++i){
        if(p == i)
            pn.multiply(c);
        c.multiply(b[i]);
        c.divide(a[i]);
        if(q == i)
            qn.multiply(r);
        r.multiply(a[i + 1]);
        r.divide(b[i]);
    }
    if(n - 1 == p)
        pn.multiply(c);
    if(n - 1 == q)
        qn.multiply(r);
    //pn.out();
    //qn.out();
    pn.multiply(qn);
    pn.multiply(a[0]);
    pn.out();
    return 0;
}
