#include <bits/stdc++.h>
using namespace std;

bool query(int x, int y) {
    if (x <= 0 || x > 100 || y <= 0 || y > 100)
        return false;
    cout << "? " << x << " " << y << endl;
    cout.flush();
    string ans;
    cin >> ans;
    return (ans == "inside");
}

void answer(bool result) {
    if (result) {
        cout << "! square" << endl;
    } else {
        cout << "! rectangle" << endl;
    }
    cout.flush();
    exit(0);
}

int main() {
    vector<pair<int,int>> vt;
    int mn_x = 100;
    int mn_y = 100;
    int mx_x = 0;
    int mx_y = 0;
    for (int i = 20; i < 100; i+=20) {
        for (int j = 20; j < 100; j+=20) {
            if(query(i,j)) vt.push_back({i,j});
        }
    }
    if(vt.size() == 0) answer(false);
    for (int i = 0; i < vt.size(); ++i) {
        mn_x = min(mn_x, vt[i].first);
        mn_y = min(mn_y, vt[i].second);
        mx_x = max(mx_x, vt[i].first);
        mx_y = max(mx_y, vt[i].second);
    }
    int LX = 0;
    int RX = 0;
    int DY = 0;
    {
        int l = mn_x-20;
        int r = mn_x;
        int y = mn_y;
        while (l != r){
            int m = (l+r)>>1;
            if(query(m,y)) r = m;
            else l = m+1;
        }
        LX = l;
    }

    {
        int l = mx_x;
        int r = mx_x+21;
        int y = mn_y;
        while (l != r){
            int m = (l+r)>>1;
            if(query(m,y)) l = m+1;
            else r = m;
        }
        RX = l-1;
    }
    {
        int l = mn_y-20;
        int r = mn_y;
        int x = mn_x;
        while (l != r){
            int m = (l+r)>>1;
            if(query(x,m)) r = m;
            else l = m+1;
        }
        DY = l;
    }
    int UYM = DY+(RX-LX);
    if(query(mn_x,UYM) and !query(mn_x,UYM+1))
        answer(true);
    else answer(false);
}
