using System;

public class Program
{
    public static void Main(string[] args)
    {
        string message = "They can not do it!";
        var loadMass = SplitString(Console.ReadLine());
        var carLoad = SplitString(Console.ReadLine());


        if (CarCanHoldMass(31, loadMass, 0, carLoad) == true && CarCanHoldMass(0, loadMass, 1, carLoad) == true)
            message = "They both can do it!";
        else if (CarCanHoldMass(31, loadMass, 0, carLoad) == true && CarCanHoldMass(0, loadMass, 1, carLoad) == false)
            message = "Vasyl can do it!";
        else if (CarCanHoldMass(31, loadMass, 0, carLoad) == false && CarCanHoldMass(0, loadMass, 1, carLoad) == true)
            message = "Petro can do it!";
        else
        {
            for (int i = 0; i <= 31; i++)
            {
                if (CarCanHoldMass(i, loadMass, 0, carLoad) == true && CarCanHoldMass(i, loadMass, 1, carLoad) == true)
                {
                    Console.WriteLine("They need to work together!");
                    Console.WriteLine("Vasyl: " + PrintCarLoadMass(i, loadMass, 0));
                    Console.WriteLine("Petro: " + PrintCarLoadMass(i, loadMass, 1));
                    return;
                }
            }
        }

         Console.WriteLine(message);
    }

    public static int[] SplitString(string input)
    { 
        var words = input.Split(' ');
        var numbers = new int[words.Length];

        for (int i = 0; i < words.Length; i++)
        {
            numbers[i] = int.Parse(words[i]);
        }

        return numbers;
    }

    public static int CarLoadMass(int i, int[] loadMass)
    {
        int load = 0;
        if((i & 1) == 1)
            load = load + loadMass[0];
        if((i & 2) == 2)
            load = load + loadMass[1];
        if ((i & 4) == 4)
            load = load + loadMass[2];
        if ((i & 8) == 8)
            load = load + loadMass[3];
        if ((i & 16) == 16)
            load = load + loadMass[4];

        return load;
    }

    public static string PrintCarLoadMass(int i, int[] loadMass, int car)
    {
        var combinationToCompute = (car == 0) ? i : 31 - i;

        string message = string.Empty;
        if ((combinationToCompute & 1) == 1)
            message = (message + " 1").Trim();
        if ((combinationToCompute & 2) == 2)
            message = (message + " 2").Trim();
        if ((combinationToCompute & 4) == 4)
            message = (message + " 3").Trim();
        if ((combinationToCompute & 8) == 8)
            message = (message + " 4").Trim();
        if ((combinationToCompute & 16) == 16)
            message = (message + " 5").Trim();

        return message;
    }

    public static bool CarCanHoldMass(int i, int[] loadMass, int car, int[] carLoad)
    {
        var combinationToCompute = (car == 0) ? i : 31 - i;
        var mass = CarLoadMass(combinationToCompute, loadMass);

        if (mass <= carLoad[car])
            return true;
        else
            return false;
    }
}
