#include <bits/stdc++.h>

using namespace std;
using ll = long long;

ll n, m, q, k, x, y, a, b, c, d, e;

map<ll, ll> factor(ll x) {
    map<ll, ll> ans;
    for (int i = 2; i * i <= x; i++) {
        while (x % i == 0) {
            x /= i;
            ans[i]++;
        }
    }
    if (x > 1) {
        ans[x]++;
    }
    return ans;
}

void solve() {
    cin >> n;
    vector<ll> v1(n);
    vector<ll> v2(n);
    for (int i = 0; i < n; i++) {
        cin >> v1[i];
    }
    for (int i = 0; i < n - 1; i++) {
        cin >> v2[i];
    }
    cin >> y >> x;
    map<ll, ll> mp;
    for (int i = 0; i < x; i++) {
        auto mp1 = factor(v1[i]);
        for (auto j : mp1) {
            mp[j.first] += j.second;
        }
    }
    for (int i = 0; i < x - 1; i++) {
        auto mp1 = factor(v2[i]);
        for (auto j : mp1) {
            mp[j.first] -= j.second;
        }
    }
    for (int i = 0; i < y - 1; i++) {
        auto mp1 = factor(v1[i]);
        for (auto j : mp1) {
            mp[j.first] -= j.second;
        }
    }
    for (int i = 0; i < y - 1; i++) {
        auto mp1 = factor(v2[i]);
        for (auto j : mp1) {
            mp[j.first] += j.second;
        }
    }
    map<ll, ll> ans;
    for (auto i : mp) {
        if (i.second != 0) {
            ans[i.first] = i.second;
        }
    }
    if (ans.size() == 0) {
        cout << "1 1\n";
        return;
    }
    for (auto i : ans) {
        cout << i.first << ' ' << i.second << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

	solve();
}
