#include <bits/stdc++.h>
using namespace std;

using ll = long long;

constexpr ll INF = 1000000000000000000LL;

ll n, m, q, k, x, y, a, b, c;
ll X1 = 10, Y1 = 10, X2 = 30, Y2 = 30;

map< pair<ll, ll>, bool > mp;

ll randint(ll x, ll y) {
    return (rand() % (y - x + 1)) + x;
}

ll inside(pair<ll, ll> b) {
    return (X1 <= b.first && b.first <= X2) && (Y1 <= b.second && b.second <= Y2);
}

bool query(int x, int y) {
    if (mp.count({x, y})) {
        return mp[{x, y}];
    }
    if (x <= 0 || x > 100 || y <= 0 || y > 100)
        return false;
    cout << "? " << x << " " << y << endl;
    cout.flush();
    string ans = "outside";
    cin >> ans;
    // if (inside({x, y})) {
    //     ans = "inside";
    // }
    // cout << ans << '\n';
    mp[{x, y}] = (ans == "inside");
    return (ans == "inside");
}

void answer(bool result) {
    if (result) {
        cout << "! square" << endl;
    } else {
        cout << "! rectangle" << endl;
    }
    cout.flush();
    exit(0);
}

int main() {
    srand(time(NULL));
    vector< pair<ll, ll> > v;
    ll ax1 = INF, ax2 = -1;
    ll ay1 = INF, ay2 = -1;
    bool fl = 0;
    for (int i = 20; i <= 100; i += 20) {
        for (int j = 20; j <= 100; j += 20) {
            if (query(i, j)) {
                ax1 = i;
                ay1 = j;
                fl = 1;
                break;
            }
        }
        if (fl) {
            break;
        }
    }
    if (ay1 == -1) {
        answer(0);
    }
    fl = 0;
    for (int i = 100; i >= 20; i -= 20) {
        for (int j = 100; j >= 20; j -= 20) {
            if (query(i, j)) {
                ax2 = i;
                ay2 = j;
                fl = 1;
                break;
            }
        }
        if (fl) {
            break;
        }
    }
    // cout << ax1 << ' ' << ay1 << '\n';
    // cout << ax2 << ' ' << ay2 << '\n';
    ll l = ax2, r = min(100LL, ax2 + 19);
    // cout << '\t' << l << ' ' << r << '\n';
    while (r > l) {
        ll mid = r - (r - l) / 2;
        // cout << '\t' << mid << '\n';
        if (query(mid, ay1)) {
            l = mid;
        }
        else {
            r = mid - 1;
        }
    }
    ll cx2 = l;
    l = max(0LL, ax1 - 19);
    r = ax1;
    while (r > l) {
        ll mid = (r + l) / 2;
        if (query(mid, ay1)) {
            r = mid;
        }
        else {
            l = mid + 1;
        }
    }
    ll cx1 = l;
    l = ay2;
    r = min(100LL, ay2 + 19);
    while (r > l) {
        ll mid = r - (r - l) / 2;
        if (query(ax1, mid)) {
            l = mid;
        }
        else {
            r = mid - 1;
        }
    }
    ll cy2 = l;
    ll cy1 = cy2 - (cx2 - cx1);
    // cout << cx1 << ' ' << cy1 << '\n';
    // cout << cx2 << ' ' << cy2 << '\n';
    answer(query(cx1, cy1) && !query(cx1, cy1 - 1));
}