#include <bits/stdc++.h>
using namespace std;

using ll = long long;

constexpr ll INF = 1000000000000000000LL;

ll n, m, q, k, x, y, a, b, c;
ll X1 = 1, Y1 = 1, X2 = 39, Y2 = 39;
ll cnt = 0;

map< pair<ll, ll>, bool > mp;

ll randint(ll x, ll y) {
    return (rand() % (y - x + 1)) + x;
}

ll inside(pair<ll, ll> b) {
    return (X1 <= b.first && b.first <= X2) && (Y1 <= b.second && b.second <= Y2);
}

bool query(int x, int y) {
    if (mp.count({x, y})) {
        return mp[{x, y}];
    }
    if (x <= 0 || x > 100 || y <= 0 || y > 100)
        return false;
    cnt++;
    cout << "? " << x << " " << y << endl;
    cout.flush();
    string ans = "outside";
    if (inside({x, y})) {
        ans = "inside";
    }
    cin >> ans;
    // cout << ans << '\n';
    mp[{x, y}] = (ans == "inside");
    return (ans == "inside");
}

void answer(bool result) {
    if (result) {
        cout << "! square" << endl;
    } else {
        cout << "! rectangle" << endl;
    }
    cout.flush();
    // cout << cnt << " queries" << endl;
    exit(0);
}

bool avail(ll cx1, ll cy1, ll cx2, ll cy2) {
    if (cx1 <= 0 || cx1 > 100 || cy1 <= 0 || cy1 > 100) {
        return false;
    }
    if (cx2 <= 0 || cx2 > 100 || cy2 <= 0 || cy2 > 100) {
        return false;
    }
    for (int i = cx1; i <= cx2; i++) {
        for (int j = cy1; j <= cy2; j++) {
            if (mp.count({i, j})) {
                if (mp[{i, j}] == 0) {
                    return 0;
                }
            }
        }
    }
    return 1;
}

void solve1() {
    vector< pair<ll, ll> > v;
    ll ax1 = INF, ax2 = -1;
    ll ay1 = INF, ay2 = -1;
    bool fl = 0;
    for (int i = 17; i <= 100; i += 17) {
        for (int j = 17; j <= 100; j += 17) {
            if (query(i, j)) {
                ax1 = i;
                ay1 = j;
                fl = 1;
                break;
            }
        }
        if (fl) {
            break;
        }
    }
    if (ay1 == -1) {
        answer(0);
    }
    fl = 0;
    for (int i = 85; i >= 17; i -= 17) {
        for (int j = 85; j >= 17; j -= 17) {
            if (query(i, j)) {
                ax2 = i;
                ay2 = j;
                fl = 1;
                break;
            }
        }
        if (fl) {
            break;
        }
    }
    // cout << cnt << " queries" << endl;
    // cout << ax1 << ' ' << ay1 << '\n';
    // cout << ax2 << ' ' << ay2 << '\n';
    ll l = ax2, r = min(100LL, ax2 + 16);
    // cout << '\t' << l << ' ' << r << '\n';
    while (r > l) {
        ll mid = r - (r - l) / 2;
        // cout << '\t' << mid << '\n';
        if (query(mid, ay1)) {
            l = mid;
        }
        else {
            r = mid - 1;
        }
    }
    ll cx2 = l;
    // cout << cnt << " queries" << endl;
    l = max(0LL, ax1 - 16);
    r = ax1;
    while (r > l) {
        ll mid = (r + l) / 2;
        if (query(mid, ay1)) {
            r = mid;
        }
        else {
            l = mid + 1;
        }
    }
    ll cx1 = l;
    // cout << cnt << " queries" << endl;
    l = ay2;
    r = min(100LL, ay2 + 16);
    while (r > l) {
        ll mid = r - (r - l) / 2;
        if (query(ax1, mid)) {
            l = mid;
        }
        else {
            r = mid - 1;
        }
    }
    ll cy2 = l;
    // cout << cnt << " queries" << endl;
    ll cy1 = cy2 - (cx2 - cx1);
    // cout << cx1 << ' ' << cy1 << '\n';
    // cout << cx2 << ' ' << cy2 << '\n';
    answer(query(cx1, cy1) && !query(cx1, cy1 - 1));
}

void solve2() {
    vector< pair<ll, ll> > v;
    for (int i = 17; i <= 100; i += 17) {
        for (int j = 17; j <= 100; j += 17) {
            v.push_back({i, j});
        }
    }
    // swap(v[0], v[21]);
    // swap(v[4], v[22]);
    // swap(v[20], v[23]);
    // for (int i = 0; i < v.size(); i++) {
    //     cout << i << ' ' << v[i].first << ' ' << v[i].second << '\n';
    // }
    for (int i = 0; i < v.size(); i++) {
        swap(v[i], v[randint(i, v.size() - 1)]);
    }
    x = -1;
    y = -1;
    for (int i = 0; i < v.size(); i++) {
        // cout << v[i].first << ' ' << v[i].second << '\n';
        if (query(v[i].first, v[i].second)) {
            x = v[i].first;
            y = v[i].second;
            break;
        }
    }
    if (x == -1) {
        answer(0);
    }
    ll l = x, r = 100;
    for (ll i = x + 1; i <= 100; i++) {
        if (!avail(x, y, i, y)) {
            r = min(r, i - 1);
            break;
        }
    }
    while (r > l) {
        ll mid = r - (r - l) / 2;
        if (query(mid, y)) {
            l = mid;
        }
        else {
            r = mid - 1;
        }
    }
    ll cx2 = l;
    l = 1;
    r = x;
    for (ll i = x - 1; i > 0; i--) {
        if (!avail(i, y, cx2, y)) {
            l = min(l, i + 1);
            break;
        }
    }
    while (r > l) {
        ll mid = (r + l) / 2;
        if (query(mid, y)) {
            r = mid;
        }
        else {
            l = mid + 1;
        }
    }
    ll cx1 = l;
    l = y;
    r = 100;
    for (ll i = y + 1; i <= 100; i++) {
        if (!avail(cx1, y, cx2, i)) {
            r = min(r, i - 1);
            break;
        }
    }
    while (r > l) {
        ll mid = r - (r - l) / 2;
        if (query(x, mid)) {
            l = mid;
        }
        else {
            r = mid - 1;
        }
    }
    ll cy2 = l;
    l = 1;
    r = y;
    ll cy1 = cy2 - (cx2 - cx1);
    // cout << cx1 << ' ' << cy1 << '\n';
    // cout << cx2 << ' ' << cy2 << '\n';
    answer(query(cx1, cy1) && !query(cx1, cy1 - 1));
}

int main() {
    srand(time(NULL));
    if (rand() % 3) {
        solve2();
    }
    else {
        solve1();
    }
}