#include <bits/stdc++.h>
using namespace std;

using ll = long long;

constexpr ll INF = 1000000000000000000LL;
constexpr ll sz = 33;

ll n, m, q, k, x, y, a, b, c;
// ll X1 = 1, Y1 = 1, X2 = 39, Y2 = 39;
ll cnt = 0;

map< pair<ll, ll>, bool > mp;

ll randint(ll x, ll y) {
    return (rand() % (y - x + 1)) + x;
}

ll inside(pair<ll, ll> b) {
    return (X1 <= b.first && b.first <= X2) && (Y1 <= b.second && b.second <= Y2);
}

ll inside2(pair< pair<ll, ll>, pair<ll, ll> > a, pair<ll, ll> b) {
    return (a.first.first <= b.first && b.first <= a.second.first) && (a.first.second <= b.second && b.second <= a.second.second);
}

bool query(int x, int y) {
    if (mp.count({x, y})) {
        return mp[{x, y}];
    }
    if (x <= 0 || x > 100 || y <= 0 || y > 100)
        return false;
    cnt++;
    cout << "? " << x << " " << y << endl;
    cout.flush();
    string ans = "outside";
    if (inside({x, y})) {
        ans = "inside";
    }
    cin >> ans;
    // cout << ans << '\n';
    mp[{x, y}] = (ans == "inside");
    return (ans == "inside");
}

void answer(bool result) {
    if (result) {
        cout << "! square" << endl;
    } else {
        cout << "! rectangle" << endl;
    }
    cout.flush();
    // cout << cnt << " queries" << endl;
    exit(0);
}

bool avail(ll cx1, ll cy1, ll cx2, ll cy2) {
    if (cx1 <= 0 || cx1 > 100 || cy1 <= 0 || cy1 > 100) {
        return false;
    }
    if (cx2 <= 0 || cx2 > 100 || cy2 <= 0 || cy2 > 100) {
        return false;
    }
    for (int i = cx1; i <= cx2; i++) {
        for (int j = cy1; j <= cy2; j++) {
            if (mp.count({i, j})) {
                if (mp[{i, j}] == 0) {
                    return 0;
                }
            }
        }
    }
    return 1;
}

void solve() {
    vector< pair< pair<ll, ll>, pair<ll, ll> > > v;
    vector< pair<ll, ll> > q(sz);
    vector<ll> ans;
    for (int i = 0; i < sz; i++) {
        q[i].first = rand() % 100 + 1;
        q[i].second = rand() % 100 + 1;
        ans.push_back(query(q[i].first, q[i].second));
    }
    for (int i = 1; i <= 100; i++) {
        for (int j = 1; j <= 100; j++) {
                for (int i1 = i; i1 <= 100; i1++) {
                    for (int j1 = j; j1 <= 100; j1++) {
                        if ((j1 - j) * (i1 - i) * 25 >= 10000) {
                            bool fl = 1;
                            pair< pair<ll, ll>, pair<ll, ll> > pr = {{i, j}, {i1, j1}};
                            for (int i = 0; i < sz; i++) {
                                if (inside2(pr, q[i]) != ans[i]) {
                                    fl = 0;
                                    break;
                                }
                            }
                            if (fl) {
                                v.push_back(pr);
                            }
                        }
                    }
                }
            }
        }
    pair< pair<ll, ll>, pair<ll, ll> > pr = v[rand() % v.size()];
    // cout << v.size() << '\n';
    answer(pr.second.first - pr.first.first == pr.second.second - pr.first.second);
}

int main() {
    srand(time(NULL));
    solve();
}