#include <bits/stdc++.h>
#include <vector>
using namespace std;

bool query(int x, int y) {
    if (x <= 0 || x > 100 || y <= 0 || y > 100)
        return false;
    cout << "? " << x << " " << y << endl;
    cout.flush();
    string ans;
    cin >> ans;
    return (ans == "inside");
}

void answer(bool result) {
    if (result) {
        cout << "! square" << endl;
    } else {
        cout << "! rectangle" << endl;
    }
    cout.flush();
    exit(0);
}

int main() {
    vector<pair<int, int>> found;
    pair<int, int> top_left(100, 100), bot_right(0, 0);
    for(int y = 1 ; y < 100; y+=4) {
        for(int x = 1; x < 100; x+=4) {
            if(query(x, y)) {
                found.push_back(make_pair(x, y));
                if(x >= bot_right.first && y >= bot_right.second) {
                    bot_right = make_pair(x, y);
                }
                if(x <= top_left.first && y <= top_left.second) {
                    top_left = make_pair(x, y);
                }
            }
        }
    }

    while(top_left.first > 1) {
        top_left.first--;
        if(!query(top_left.first, top_left.second)) {
            top_left.first++;
            break;
        }
    }

    while(top_left.second > 1) {
        top_left.second--;
        if(!query(top_left.first, top_left.second)) {
            top_left.second++;
            break;
        }
    }

    while(bot_right.first < 100) {
        bot_right.first++;
        if(!query(bot_right.first, bot_right.second)) {
            bot_right.first--;
            break;
        }
    }

    while(bot_right.second < 100) {
        bot_right.second++;
        if(!query(bot_right.first, bot_right.second)) {
            bot_right.second--;
            break;
        }
    }

    if(bot_right.first - top_left.first == bot_right.second - top_left.second) {
        answer(true);
    } else answer(false);
}