#include <bits/stdc++.h>
#include <cmath>
using namespace std;

int head[1005];
int support[1005];
int ans[10000][2] = {0};

int nsd(int a, int b){
    if(a>=b){
        a-=b*(a/b);
    } else {
        b-=a*(b/a);
    }
    if(a==0||b==0){
        return (a+b);
    } else {
        return nsd(a, b);
    }
}
void heapify(int m[][2], int n, int par){
    int biggest = par;
    if(2*par<=n&&m[2*par][0]>m[biggest][0]){
        biggest=2*par;
    }
    if(2*par+1<=n&&m[2*par+1][0]>m[biggest][0]){
        biggest=2*par+1;
    }
    if(par!=biggest){
        swap(m[biggest], m[par]);
        heapify(m, n, biggest);
    }
}

void heap_sort(int m[][2], int n){
    for(int i=n/2; i>=1; i--){
        heapify(m, n, i);
    }
    for(int i=n; i>1; i--){
        swap(m[1], m[i]);
        heapify(m, i-1, 1);
    }
}

void multiply(int ans[][2], int roz, int num){
    bool found;
    for(int i=2; i<=num; i++){
        if(num%i==0){
            num=num/i;
            found=false;
            for(int j=1; j<=roz; j++){
                if(i==ans[j][0]){
                    ans[j][1]++;
                    found=true;
                    break;
                }
            }
            if(!found){
                roz++;
                ans[roz][0]=i;
                ans[roz][1]++;
            }
            i--;
        }
       
    }
}
void divide(int ans[][2], int &roz, int num){
    bool found;
    for(int i=2; i<=num; i++){
        if(num%i==0){
            num=num/i;
            found=false;
            for(int j=1; j<=roz; j++){
                if(i==ans[j][0]){
                    ans[j][1]--;
                    found=true;
                    break;
                }
            }
            if(!found){
                roz++;
                ans[roz][0]=i;
                ans[roz][1]--;
            }
            i--;
        }
        
    }
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

	int n, p, q, roz;
    bool is1 = true;
    roz=0;
	cin>>n;
    for(int i=1; i<=n; i++){
        cin >> head[i];
    }
    for(int i=1; i<n; i++){
        cin >> support[i];
    }
    cin >> p >> q;
    if(p==q){
        cout << head[p];
    } else if(p==(q+1)){
        cout << support[q];
    } else {
        if(q>p){
            for(int i=p; i<q; i++){
                multiply(ans, roz, head[i]);
                divide(ans, roz, support[i]);
            }
            multiply(ans, roz, head[q]);
        } else {
            for(int i=p-1; i>q; i--){
                multiply(ans, roz, support[i]);
                divide(ans, roz, head[i]);
            }
            multiply(ans, roz, support[q]);
        }
        heap_sort(ans, roz);
        for(int i=1; i<=roz; i++){
            if(ans[i][1]!=0){
                cout << ans[i][0] << ' ' << ans[i][1] << '\n';
                is1=false;
            }
        }
        if(is1){
            cout << 1 << ' ' << 1;
        }
    }
}
