import math

n = int(input())
big_diagonal = list(int(i) for i in input().split(' '))
side_diagonal = list(int(i) for i in input().split(' '))
coords = list(int(i) for i in input().split(' '))
map = [
    0, 0, 0, 0, big_diagonal[-1],
    0, 0, 0, big_diagonal[-2], side_diagonal[-1],
    0, 0, big_diagonal[-3], side_diagonal[-2], 0,
    0, big_diagonal[-4], side_diagonal[-3], 0, 0,
    big_diagonal[-5], side_diagonal[-4], 0, 0, 0
]

coords_int = n*(coords[1] - 1) + coords[0] - 1

def primefactorise(number):
    global primeDivisorsList
    
    primes = []
    primeDivisorsList = []
    primeDivisorsDictionary = {}

    def checkPrime(prime, number):
        global primeDivisorsList
        if number % prime == 0:
            primeDivisorsList.append(prime)
            number /= prime
            checkPrime(prime, number)
        return(number, primeDivisorsList)

        
    for x in range(2, number + 1):
        for y in range(2, int(math.sqrt(x)) + 1):
            if x % y == 0:
                break
        else:
            primes.append(x)

    for prime in primes:
        checkPrime(prime, number)

    for i in primeDivisorsList:
        if i in primeDivisorsDictionary:
            primeDivisorsDictionary[i] += 1
        else:
            primeDivisorsDictionary[i] = 1

    return primeDivisorsDictionary

primeFactorisationTuples = primefactorise(map[coords_int])

for t in primeFactorisationTuples.items():
    print(f'{t[0]} {t[1]}')
