/*#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2,popcnt,bmi,bmi2,abm")*/

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define ld long double
#define fr first
#define sc second
#define pll pair<long long, long long>
#define pii pair<int, int>
#define pb push_back

const int inf=1000000000;
const int o = (int)ceil(sqrt(INT_MAX))-10;

int m[1000][1000], need[1000][1000];
int p, q, n;
vector<int> primes;
vector<int> cur;
bool prime[o];

void preprocess()
{
    prime[0] = prime[1] = true;
    for(int i=2; i<o; ++i)
        if(!prime[i])
            if(i*1ll*i<o)
                for(int j=i*i; j<o; j+=i)
                    prime[j] = true;
    for(int i=0; i<=o; i++)    if(!prime[i])   primes.pb(i);
    cur.resize(primes.size());
    for(int i=0; i<cur.size(); i++) cur[i]=0;
}

void case1()
{
    for(int i=p; i>=0; i--)
    {
        for(int j=q; j<i; j++)
        {
            need[i][j+1]+=need[i][j];
            need[i-1][j]+=need[i][j];
            need[i-1][j+1]-=need[i][j];
        }
    }
}

void case2()
{
    for(int i=p; i<n; i++)
    {
        for(int j=q; j>i+1; j--)
        {
            need[i][j-1]+=need[i][j];
            need[i+1][j]+=need[i][j];
            need[i+1][j-1]-=need[i][j];
        }
    }
}

void solve()
{
    cin>>n;
    for(int i=0; i<n; i++)
    {
        cin>>m[i][i];
    }
    for(int i=0; i<n-1; i++)
    {
        cin>>m[i][i+1];
    }
    cin>>p>>q;
    p--;
    q--;
    swap(p, q);
    need[p][q]=1;
    if(q-p<0)   case1();
    else if(q-p>1)  case2();
    /*for(int i=n-1; i>=0; i--)
    {
        for(int j=0; j<n; j++)
        {
            cout<<need[i][j]<<' ';
        }
        cout<<'\n';
    }*/
    for(int i=0; i<n; i++)
    {
        int k=m[i][i];
        for(int j=0; j<primes.size(); j++)
        {
            if(k==1)    break;
            while(!(k%primes[j]))
            {
                k/=primes[j];
                cur[j]+=need[i][i];
                //if(need[i][i])  cout<<primes[j]<<'\n';
            }
        }
    }
    for(int i=0; i<n-1; i++)
    {
        int k=m[i][i+1];
        for(int j=0; j<primes.size(); j++)
        {
            if(k==1)    break;
            while(!(k%primes[j]))
            {
                k/=primes[j];
                cur[j]+=need[i][i+1];
                //if(need[i][i+1])  cout<<primes[j]<<'\n';
            }
        }
    }
    bool flag=0;
    for(int i=0; i<cur.size(); i++)
    {
        if(cur[i])
        {
            cout<<primes[i]<<' '<<cur[i]<<'\n';
            flag=1;
        }
    }
    if(!flag)   cout<<"1 1\n";
    return;
}

int main()
{
    /*ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);*/
    preprocess();
    int tttt=1;
   // cin>>tttt;
    while(tttt--)
    {
        solve();
    }
    return 0;
}
