#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

const int DIM = 1000;

struct fr {
    ll a, b = 1;
};

ll gcd (ll a, ll b) {
    a = abs(a); b = abs(b);
    while (a > 0 && b > 0) {
        if (a>b) a%=b;
        else b%=a;

    }
    return a+b;
}

fr simp(fr a) {
    ll g = gcd(a.a,a.b);
    return {a.a/g,a.b/g};
}

void pr(fr a) {
    ll x = a.a, y = a.b;
    vector<pair<ll,ll>> v;
    ll sx = sqrt(x);
    for (int i = 2; i <= sx; i++) {
        ll k = 0;
        while(x%i == 0) {
            x /= i;
            k++;
        }
        if (k > 0) v.push_back({i,k});
    }
    if (x!=1) v.push_back({x,1});
    ll sy = sqrt(y);
    for (int i = 2; i <= sy; i++) {
        ll k = 0;
        while(y%i == 0) {
            y /= i;
            k++;
        }
        if (k > 0) v.push_back({i,-k});
    }
    if (y!=1) v.push_back({y,-1});
    sort(v.begin(),v.end());
    if (v.size() == 0) {
        cout << "1 1";
        return;
    }
    for (auto i : v) cout << i.first << " " << i.second << endl;
}

fr dv (fr a, fr b) {
    //pr(a); pr(b);
    return simp({a.a * b.b , a.b * b.a});
}



ll n;
ll d1[DIM], d2[DIM];
fr a[DIM];
fr b[DIM];

void fil() {
    ll x = n-1, y = 0;
    a[x] = {1,1};
    b[y] = dv ( { d1[0] } , a[x] );
    y++;
    b[y] = dv ( { d2[0] } , a[x] );
    while (y < n) {
        x--;
        a[x] = dv ( { d1[y] } , b[y] );
        y++;
        b[y] = dv ( { d2[y-1] } , a[x] );
    }
    x--;
    a[x] = dv ( { d1[y-1] } , b[y] );

    /*for (int i = 0; i < n; i++) {
        cout << a[i].a << " / " << a[i].b << endl;
    }
    cout << endl;
    for (int i = 0; i < n; i++) {
        cout << b[i].a << " / " << b[i].b << endl;
    }*/
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

	cin >> n;
    for (int i = 0; i < n; i++) cin >> d1[i];
    for (int i = 0; i < n-1; i++) cin >> d2[i];
    fil();
    ll x, y;
    cin >> x >> y;
    fr res = simp({a[n-y].a * b[x-1].a , a[n-y].b * b[x-1].b});
    pr(res);
}
