#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef pair<ll,ll> pll;

const int DIM = 1000;

struct fr {
    vector<pll> v;
};

fr cnst(ll x) {
    if (x == 1) {
        fr a;
        a.v.push_back({ 1,1 });
        return a;
    }
    fr a;
    ll sx = sqrt(x);
    for (int i = 2; i <= sx; i++) {
        ll k = 0;
        while (x % i == 0) {
            x /= i;
            k++;
        }
        if (k > 0) a.v.push_back({ i,k });
    }
    if (x > 1) a.v.push_back({ x,1 });
    return a;
}

void prn(fr x) {
    for (auto i : x.v) cout << i.first << " " << i.second << endl;
}

fr dv(fr a, fr b) {
    ll x = 0;
    ll y = 0;
    fr xx;
    if (a.v[x].first == 1) x++;
    if (b.v[y].first == 1) y++;
    while (x < a.v.size() && y < b.v.size()) {
        if (a.v[x].first < b.v[y].first) {
            xx.v.push_back(a.v[x]);
            x++;
        }
        else if (a.v[x].first > b.v[y].first) {
            xx.v.push_back({ b.v[y].first, -b.v[y].second });
            y++;
        }
        else {
            if (a.v[x].second - b.v[y].second != 0 )
                xx.v.push_back({ a.v[x].first, a.v[x].second - b.v[y].second });
            x++;
            y++;
        }
    }
    while (x < a.v.size()) {
        xx.v.push_back(a.v[x]);
        x++;
    }
    while (y < b.v.size()) {
        xx.v.push_back({ b.v[y].first, -b.v[y].second });
        y++;
    }
    if (xx.v.size() == 0) xx.v.push_back({ 1,1 });
    return xx;
}

ll n;
fr d1[DIM], d2[DIM];
fr a[DIM];
fr b[DIM];

void fil() {
    ll x = n - 1, y = 0;
    a[x] = cnst(1);
    b[y] = dv(d1[0], a[x]);
    y++;
    b[y] = dv(d2[0], a[x]);
    //prn(a[x]);
    //prn(b[0]);
    //prn(b[1]);
    while (y < n-1) {
        //cout << x << " " << y << endl;
        x--;
        a[x] = dv(d1[y], b[y]);
        //prn(d1[y]); prn(b[y]);
        //prn(a[x]);
        y++;
        b[y] = dv(d2[y - 1], a[x]);
        
       
        //prn(b[y]);
        //cout << endl;
        
    }
    x--;
    a[x] = dv(d1[y], b[y]);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    
    ll buf;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> buf;
        d1[i] = cnst(buf);
    }
    for (int i = 0; i < n - 1; i++) {
        cin >> buf;
        d2[i] = cnst(buf);
    }
    fil();
    //for (int i = 0; i < n; i++) prn(a[i]);
    //for (int i = 0; i < n; i++) prn(b[i]);
    ll x1, y1;
    cin >> x1 >> y1;
    fr x = a[n - y1];
    fr y = b[x1 - 1];
    fr ny;
    for (auto i : y.v) ny.v.push_back({ i.first, -i.second });
    prn(dv(x, ny));
}
