load = [int(i) for i in input().split(" ")]
capacity = [int(i) for i in input().split(" ")]

def deduct(decreasing, deductible):
    result = decreasing[:]
    for i in deductible:
        if i in result:
            result.remove(i);
    return result

def to_string(arr): 
    result = ""
    for i in arr:
        result += str(i)
        result += " "
    return result

def get_cominations(arr):
    if len(arr) == 0:
        return [[]]
    result = []
    for combination in get_cominations(arr[1:]):
        result += [combination, combination + [arr[0]]]
    return result

def find_combination(arr, load, cap):
    best_arr = []
    for i in arr:
        arr_sum = 0
        for n in i:
            arr_sum += n
        if arr_sum <= cap and arr_sum > sum(best_arr):
            best_arr = i
    return best_arr

def get_indexes(arr, items):
    result = []
    for i in items:
        result.append(arr.index(i) + 1)
    return result
        
def find_answer(load, cap):
    combinations = get_cominations(load);
    maxcomb = find_combination(combinations, load, max(cap))
    mincomb = deduct(load, maxcomb)
    if sum(mincomb) <= min(cap):
        if cap.index(max(cap)) == 0:
            return [get_indexes(load, maxcomb), get_indexes(load, mincomb)]
        else: 
            return [get_indexes(load, mincomb), get_indexes(load, maxcomb)]
    else:
        return False;

def is_capable(load, cap):
    return sum(load) <= cap

def main():
    if is_capable(load, capacity[0]) and is_capable(load, capacity[1]):
        print("They both can do it!")
    elif is_capable(load, capacity[0]):
        print("Vasyl can do it!")
    elif is_capable(load, capacity[1]):
        print("Petro can do it!")
    else:
        ans = find_answer(load, capacity)
        if ans:
            print("They need to work together!")
            print("Vasyl: " + to_string(ans[0]))
            print("Petro: " + to_string(ans[1]))

main()