import sys

def query(x: int, y: int) -> bool:
    if x <= 0 or x > 100 or y <= 0 or y > 100:
        return False
    print('?', x, y)
    sys.stdout.flush()
    return input() == 'inside'


def answer(result: bool):
    if result:
        print('! square')
    else:
        print('! rectangle')
    sys.stdout.flush()


max_bounds = None
min_bounds = None

def search():
    scale_factor = 8
    found = False
    while not found:
        step = 100 / scale_factor
        coords = []
        for y in range(scale_factor):
            for x in range(scale_factor):
                if round(x * step) > 0 and round(x * step) <= 99 and round(y * step) > 0 and round(y * step) <= 99:
                    coords.append((round(x * step), round(y * step)))
        for coord in coords:
            if query(coord[0], coord[1]): 
                found = True
                min_bounds = [[coord[0], coord[0]], [coord[1], coord[1]]]              
                max_bounds = [[(coords[coords.index(coord)-1][0] if coords.index(coord)-1 >= 0 else 1), (coords[coords.index(coord)+1][0] if coords.index(coord)+1 < len(coords) else 99)], [(coords[coords.index(coord)-(scale_factor-1)][1] if coords.index(coord)-(scale_factor-1) >= 0 else 1), (coords[coords.index(coord)+(scale_factor-1)][1] if coords.index(coord)+(scale_factor-1) < len(coords) else 99)]]        
        scale_factor *= 2


search()

answer(True)