#include <bits/stdc++.h>
using namespace std;

bool isInside(int x, int y) {
    if (x < 1 || x > 100 || y < 1 || y > 100)
        return false;
    cout << "? " << x << " " << y << endl;
    cout.flush();
    string ans;
    cin >> ans;
    return (ans == "inside");
}

void answer(bool result) {
    if (result) {
        cout << "! square" << endl;
    } else {
        cout << "! rectangle" << endl;
    }
    cout.flush();
    exit(0);
}

int getX(int originFind, int originConst, bool x)
{
    return x ? originFind : originConst;
}
int getY(int originFind, int originConst, bool x)
{
    return x ? originConst : originFind;
}

int approach(int originFind, int originConst, bool x, bool negative)
{
    int increments[] = 
    {
        20, 10, 4, 1
    };
    
    int multiplier = 1;
    if(negative) multiplier = -1;

    for(int increment: increments)
    {
        while(
            isInside(
                getX(originFind + increment * multiplier, originConst, x),
                getY(originFind + increment * multiplier, originConst, x)))
        {
            originFind += increment * multiplier;
        }
    }

    return originFind;
}




int main() {
    //std::srand(time(0));
    int originX, originY;
    
    do
    {
        originX = std::min((std::rand()%21) * 5 + 1, 100);
        originY = std::min((std::rand()%21) * 5 + 1, 100);
    }
    while(!isInside(originX, originY));

    int maxX = originX == 100 ? 100 : approach(originX, originY, true, false);
    int maxY = originY == 100 ? 100 : approach(originX, originY, false, false);

    int minX = originX == 0 ? 0 : approach(originX, originY, true, true);
    int minY = originY == 0 ? 0 : approach(originX, originY, false, true);

    int dx = std::abs(minX - maxX);
    int dy = std::abs(minY - maxY);

    answer(dx == dy);
}