#include <bits/stdc++.h>
using namespace std;

map<int, int> prime_factors(int n)
{
    map<int, int> factors;
    for (int i = 2; i * i <= n; i++)
    {
        while (n % i == 0)
        {
            factors[i]++;
            n /= i;
        }
    }
    if (n > 1)
        factors[n]++;
    return factors;
}

void print_factors(map<int, int> &factors)
{
    for (auto &[factor, count] : factors)
        cout << factor << " " << count << endl;
}

int main()
{
    int n;
    cin >> n;
    vector<int> main_diag(n);
    for (int i = 0; i < n; i++)
        cin >> main_diag[i];
    vector<int> side_diag(n - 1);
    for (int i = 0; i < n - 1; i++)
        cin >> side_diag[i];

    int p, q;
    cin >> p >> q;

    if (p - 1 == q)
    {
        print_factors(prime_factors(main_diag[p - 1]));
    }
    else if (p == q)
    {
        print_factors(prime_factors(side_diag[p - 1]));
    }

    return 0;
}
