#include <bits/stdc++.h>
using namespace std;

void prime_factors(int n)
{
    map<int, int> factors;
    for (int i = 2; i * i <= n; i++)
    {
        while (n % i == 0)
        {
            factors[i]++;
            n /= i;
        }
    }
    if (n > 1)
        factors[n]++;

    for (auto &[factor, count] : factors)
        cout << factor << " " << count << endl;
}

int main()
{
    int n;
    cin >> n;
    vector<int> main_diag(n);
    for (int i = 0; i < n; i++)
        cin >> main_diag[i];
    vector<int> side_diag(n - 1);
    for (int i = 0; i < n - 1; i++)
        cin >> side_diag[i];

    int p, q;
    cin >> p >> q;

    if (p == 1 && q == 1)
    {
        prime_factors(main_diag[0]);
        prime_factors(side_diag[0]);
    }
    else if (p == 1 && q == n)
    {
        prime_factors(main_diag[n - 1]);
        prime_factors(side_diag[n - 2]);
    }
    else if (p == n && q == 1)
    {
        prime_factors(main_diag[0]);
        prime_factors(side_diag[n - 2]);
    }
    else if (p == n && q == n)
    {
        prime_factors(main_diag[n - 1]);
        prime_factors(side_diag[n - 2]);
    }
    else if (p == 1)
    {
        prime_factors(main_diag[q - 1]);
        prime_factors(side_diag[q - 2]);
    }
    else if (p == n)
    {
        prime_factors(main_diag[q - 1]);
        prime_factors(side_diag[q - 2]);
    }
    else if (q == 1)
    {
        prime_factors(main_diag[p - 1]);
        prime_factors(side_diag[p - 2]);
    }
    else if (q == n)
    {
        prime_factors(main_diag[p - 1]);
        prime_factors(side_diag[p - 2]);
    }
    else if (p + 1 == q)
    {
        prime_factors(main_diag[p - 1]);
        prime_factors(side_diag[p - 2]);
    }
    else if (p - 1 == q)
    {
        prime_factors(main_diag[p - 1]);
        prime_factors(side_diag[p - 2]);
    }

    return 0;
}
