#include <bits/stdc++.h>
using namespace std;

bool query(int x, int y)
{
    if (x <= 0 || x > 100 || y <= 0 || y > 100)
        return false;
    cout << "? " << x << " " << y << endl;
    cout.flush();
    string ans;
    cin >> ans;
    return (ans == "inside");
}

void answer(bool result)
{
    if (result)
    {
        cout << "! square" << endl;
    }
    else
    {
        cout << "! rectangle" << endl;
    }
    cout.flush();
    exit(0);
}

int main()
{
    pair<int, int> leftTop, rightBottom;
    for (int i = 1; i <= 100; i++)
    {
        for (int j = 1; j <= 100; j++)
        {
            if (query(i, j))
            {
                leftTop.first = min(leftTop.first, i);
                leftTop.second = min(leftTop.second, j);
                rightBottom.first = max(rightBottom.first, i);
                rightBottom.second = max(rightBottom.second, j);
            }
        }
    }

    int horizontalSide = rightBottom.first - leftTop.first + 1;
    int verticalSide = rightBottom.second - leftTop.second + 1;

    if (horizontalSide == verticalSide)
    {
        answer(true);
    }
    else
    {
        answer(false);
    }
}