#include <bits/stdc++.h>
using namespace std;

bool query(int x, int y)
{
    if (x <= 0 || x > 100 || y <= 0 || y > 100)
        return false;
    cout << "? " << x << " " << y << endl;
    cout.flush();
    string ans;
    cin >> ans;
    return (ans == "inside");
}

void answer(bool result)
{
    if (result)
    {
        cout << "! square" << endl;
    }
    else
    {
        cout << "! rectangle" << endl;
    }
    cout.flush();
    exit(0);
}

int main()
{
    pair<int, int> leftTop, rightBottom;
    bool foundLeftTop = false;
    for (int i = 1; i <= 100; i++)
    {
        for (int j = 1; j <= 100; j++)
        {
            if (query(i, j))
            {
                leftTop = {i, j};
                foundLeftTop = true;
                break;
            }
        }
        if (foundLeftTop)
            break;
    }
    bool foundRightBottom = false;
    for (int i = 100; i >= 1; i--)
    {
        for (int j = 100; j >= 1; j--)
        {
            if (query(i, j))
            {
                rightBottom = {i, j};
                foundRightBottom = true;
                break;
            }
        }
        if (foundRightBottom)
            break;
    }

    bool isSquare = (leftTop.first == rightBottom.first || leftTop.second == rightBottom.second);
    answer(isSquare);
    return 0;
}