#include <bits/stdc++.h>
using namespace std;

bool query(int x, int y)
{
    if (x <= 0 || x > 100 || y <= 0 || y > 100)
        return false;
    cout << "? " << x << " " << y << endl;
    cout.flush();
    string ans;
    cin >> ans;
    return (ans == "inside");
}

void answer(bool result)
{
    if (result)
    {
        cout << "! square" << endl;
    }
    else
    {
        cout << "! rectangle" << endl;
    }
    cout.flush();
    exit(0);
}

void search(int leftX, int rightX, int leftY, int rightY)
{
    if (leftX > rightX || leftY > rightY)
        return;

    int midX = (leftX + rightX) / 2;
    int midY = (leftY + rightY) / 2;

    bool topLeft = query(midX, midY);
    bool topRight = query(midX + 1, midY);
    bool bottomLeft = query(midX, midY + 1);
    bool bottomRight = query(midX + 1, midY + 1);

    if (topLeft && topRight && bottomLeft && bottomRight)
    {
        int width = rightX - leftX;
        int height = rightY - leftY;
        if (width == height)
            answer(true);
        else
            answer(false);
    }
    else if (!topLeft && !topRight && !bottomLeft && !bottomRight)
    {
        return;
    }
    else
    {
        search(leftX, midX, leftY, midY);
        search(midX + 1, rightX, leftY, midY);
        search(leftX, midX, midY + 1, rightY);
        search(midX + 1, rightX, midY + 1, rightY);
    }
}

int main()
{
    search(1, 100, 1, 100);
}