#include <bits/stdc++.h>
using namespace std;

bool query(int x, int y)
{
    if (x <= 0 || x > 100 || y <= 0 || y > 100)
        return false;
    cout << "? " << x << " " << y << endl;
    cout.flush();
    string ans;
    cin >> ans;
    return (ans == "inside");
}

void answer(bool result)
{
    if (result)
    {
        cout << "! square" << endl;
    }
    else
    {
        cout << "! rectangle" << endl;
    }
    cout.flush();
    exit(0);
}

int main()
{
    int n, q;
    cin >> n >> q;
    int x, y;
    cin >> x >> y;

    int leftX = 0;
    int rightX = n - 1;
    int leftY = 0;
    int rightY = n - 1;
    int width = n;
    int height = n;
    while (true)
    {
        if (width == 1 && height == 1)
        {
            answer(true);
            break;
        }
        else
        {
            int midX = (leftX + rightX) / 2;
            int midY = (leftY + rightY) / 2;
            bool topLeft = query(midX, midY);
            bool topRight = query(midX + 1, midY);
            bool bottomLeft = query(midX, midY + 1);
            bool bottomRight = query(midX + 1, midY + 1);
            if (topLeft && topRight && bottomLeft && bottomRight)
            {
                if (width == height)
                {
                    answer(true);
                    break;
                }
                else
                {
                    answer(false);
                    break;
                }
            }
            else if (!topLeft && !topRight && !bottomLeft && !bottomRight)
            {
                break;
            }
            else
            {
                if (x <= midX && y <= midY)
                {
                    rightX = midX;
                    rightY = midY;
                }
                else if (x > midX && y <= midY)
                {
                    leftX = midX + 1;
                    rightY = midY;
                }
                else if (x <= midX && y > midY)
                {
                    rightX = midX;
                    leftY = midY + 1;
                }
                else
                {
                    leftX = midX + 1;
                    leftY = midY + 1;
                }
                width = rightX - leftX + 1;
                height = rightY - leftY + 1;
            }
        }
    }
    return 0;
}