#include <bits/stdc++.h>
using namespace std;

bool query(int x, int y)
{
    if (x <= 0 || x > 100 || y <= 0 || y > 100)
        return false;
    cout << "? " << x << " " << y << endl;
    cout.flush();
    string ans;
    cin >> ans;
    return (ans == "inside");
}

void answer(bool result)
{
    if (result)
    {
        cout << "! square" << endl;
    }
    else
    {
        cout << "! rectangle" << endl;
    }
    cout.flush();
    exit(0);
}

void search(int leftX, int rightX, int leftY, int rightY)
{
    if (leftX > rightX || leftY > rightY)
        return;

    int midX = (leftX + rightX) / 2;
    int midY = (leftY + rightY) / 2;

    if (query(midX, midY))
    {
        search(leftX, midX - 1, leftY, midY - 1);
        search(leftX, midX - 1, midY, rightY);
        search(midX, rightX, leftY, midY - 1);
        search(midX, rightX, midY, rightY);
    }
    else
    {
        search(leftX, midX - 1, leftY, midY - 1);
        search(leftX, midX - 1, midY, rightY);
        search(midX, rightX, leftY, midY - 1);
        search(midX, rightX, midY, rightY);
    }

    if (query(leftX, leftY) && query(leftX, rightY) && query(rightX, leftY) && query(rightX, rightY))
    {
        answer(true);
    }
    else
    {
        answer(false);
    }

    exit(0);
}

int main()
{
    search(1, 100, 1, 100);
}