#include <bits/stdc++.h>
using namespace std;

bool known_outside[100][100]{ false };

bool inside(int x, int y) 
{
    if (x <= 0 || x > 100 || y <= 0 || y > 100)
    {
        return false;
    }
    if (known_outside[x - 1][y - 1])
    {
        return false;
    }

    cout << "? " << x << " " << y << endl;
    string ans;
    cin >> ans;

    bool result = (ans[0] == 'i');
    if (!result)
    {
        known_outside[x - 1][y - 1] = true;
    }
    return result;
}

void answer(bool result) 
{
    if (result) 
    {
        cout << "! square" << endl;
    }
    else 
    {
        cout << "! rectangle" << endl;
    }
    exit(0);
}

int random(int lowest, int highest)
{
    return rand() % (highest - lowest + 1) + lowest;
}

int main()
{
    int x = 50;
    int y = 50;
    while(!inside(x, y))
    {
        x = random(1, 100);
        y = random(1, 100);
    }

    int left_side = x;
    int right_side = x;
    int upper_side = y;
    int lower_side = y;

    int left_bound = 1;
    int right_bound = 100;
    int upper_bound = 1;
    int lower_bound = 100;

    do
    {
        left_side--;
    } while (inside(left_side, upper_side));
    left_side++;
    do
    {
        upper_side--;
    } while (inside(left_side, upper_side));
    upper_side++;

    do
    {
        right_side++;
    } while (inside(right_side, lower_side));
    right_side--;
    do
    {
        lower_side++;
    } while (inside(right_side, lower_side));
    lower_side--;

    answer((right_side - left_side) == (lower_side - upper_side));
}