#include <bits/stdc++.h>
using namespace std;

bool query(int x, int y) {
    if (x <= 0 || x > 100 || y <= 0 || y > 100)
        return false;
    cout << "? " << x << " " << y << endl;
    cout.flush();
    string ans;
    cin >> ans;
    return (ans == "inside");
}

void answer(bool result) {
    if (result) {
        cout << "! square" << endl;
    } else {
        cout << "! rectangle" << endl;
    }
    cout.flush();
    exit(0);
}

int binary_x_top (int low, int top) {
    while (top-low>1) {
        if (query((low+top)/2, 50)) {
            low+=(top-low)/2;
        } else {
            top/=2;
        }
    }
    if (query(top, 50)) {
        return top;
    } else if (query(50, low)) {
        return low;
    } else {
        return 0;
    }
}
int binary_x_low (int low, int top) {
    while (top-low>1) {
        if (query((low+top)/2, 50)) {
            top/=2;
        } else {
            low/=(top-low)/2;
        }
    }
    if (query(top, 50)) {
        return top;
    } else if (query(50, low)) {
        return low;
    } else {
        return 0;
    }
}
int binary_y_top (int low, int top) {
    while (top-low>1) {
        if (query(50, (low+top)/2)) {
            low+=(top-low)/2;
        } else {
            top/=2;
        }
    }
    if (query(50, top)) {
        return top;
    } else if (query(50, low)) {
        return low;
    } else {
        return 0;
    }
}
int binary_y_low (int low, int top) {
    while (top-low>1) {
        if (query((low+top)/2, 50)) {
            top/=2;
        } else {
            low+=(top-low)/2;
        }
    }
    if (query(50, top)) {
        return top;
    } else if (query(50, low)) {
        return low;
    } else {
        return 0;
    }
}

int main() {
    int top_x=100, low_x=0, top_y=100, low_y=0;
    bool res=0;
    if (query(top_x, top_y)) {
        res=1;
    }
    switch (res) {
        case 1:
            top_x=binary_x_top(50, 100);
            low_x=binary_x_low(0, 50);
            top_y=binary_y_top(50, 100);
            low_y=binary_y_low(0, 50);
            if (top_x-low_x==top_y-low_y) {
                answer(true);
            } else {
                answer(false);
            }
            break;
        case 0:
            break;
    }
    answer(false);
}