#include <iostream>
#include <set>
#include <vector>
#include <climits>
#include <string>
#include <algorithm>
#include <cmath>
#include <map>

using namespace std;

typedef long long ll;
typedef long long ull;
typedef pair<int, int> pint;
typedef pair<ll, ll> pll;
typedef pair<pint, pint> ppint;

int fx, fy;
int sw = 128;
int qt = 0;

/*bool query(int x, int y) {
    if (x <= 0 || x > 100 || y <= 0 || y > 100)
        return false;
    cout << "? " << x << " " << y << endl;
    bool a = (x > 50) && (x < 71) && (y > 50) && (y < 71);
    if (a) cout << "inside\n";
    else cout << "outside\n";
    qt++;
    return a;
}*/

bool query(int x, int y) {
    if (x <= 0 || x > 100 || y <= 0 || y > 100)
        return false;
    cout << "? " << x << " " << y << endl;
    cout.flush();
    string ans;
    cin >> ans;
    return (ans == "inside");
}


void FindRect()
{
	vector<ppint> check = { ppint(pint(1,1), pint(100,100)) };
	while (true)
	{
		sw /= 2;
		vector<ppint> ncheck;
		for (int i = 0; i < check.size(); i++)
		{
            int x = (check[i].first.first + check[i].second.first) / 2;
            int y = (check[i].first.second+ check[i].second.second) / 2;
            bool ans = query(x, y);
            pint ap(x, y);
            if (ans)
            {
                fx = ap.first;
                fy = ap.second;
                return;
            }
            ncheck.push_back(ppint(check[i].first, ap));
            ncheck.push_back(ppint(ap, check[i].second));
            ncheck.push_back(ppint(pint(x, check[i].first.second), pint(check[i].second.first, y)));
            ncheck.push_back(ppint(pint(check[i].first.first, y), pint(x, check[i].second.second)));
		}
		check = ncheck;
	}
}

void findl(int* x, int* y, int sx, int sy)
{
    *x = fx;
    *y = fy;
    while ((sx != 0) || (sy != 0))
    {
        bool ans = query(*x + sx, *y + sy);
        if (ans)
        {
            *x += sx;
            *y += sy;
        }
        sx /= 2; sy /= 2;
    }
}

void answer(bool result) {
    if (result) cout << "! square" << endl;
    else cout << "! rectangle" << endl;
    cout.flush();
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    FindRect();
    int left, right, top, bottom;
    findl(&left, &fy, -sw, 0);
    findl(&right, &fy, sw, 0);
    findl(&fx, &top, 0, -sw);
    findl(&fx, &bottom, 0, sw);
    answer(abs(bottom - top) == abs(right - left));
    //cout << qt << "\n";
}