#include <bits/stdc++.h>
using namespace std;
using ll = unsigned long long;

pair<ll, ll> f(pair<ll, ll> a, pair<ll, ll> b, pair<ll, ll> c){
    ll pr = a.first, dv = a.second, d; 
    d = gcd(pr, dv);
    pr /= d;
    dv /= d;
    pr *= b.first; pr *= c.second;
    d = gcd(pr, dv);
    pr /= d;
    dv /= d;
    dv *= b.second; dv *= c.first;
    d = gcd(pr, dv);
    pr /= d;
    dv /= d;
    return {pr, dv};
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

	int n, p, q; cin>>n;
    pair<ll, ll> dp[n][n];
    for (int i = 0; i < n; i++){
        for (int j = 0; j < n; j++){
            dp[i][j].first = 0;
            dp[i][j].second = 0;
        }
    }
    for (int i = 0; i < n; i++){
        cin>>dp[n - i - 1][i].first;
        dp[n - i - 1][i].second = 1;
    }
    for (int i = 0; i + 1 < n; i++){
        cin>>dp[n - i - 1][i + 1].first;
        dp[n - i - 1][i + 1].second = 1;
    }
    cin>>p>>q;
    for (int i = 0; i < 1; i++){
        int k = n - i - 2;
        for (int j = 0; j + i + 1 < n; j++){
            dp[k][j] = f(dp[k + 1][j], dp[k][j + 1], dp[k + 1][j + 1]);
            k--;
        }
    }
    /*
    for (int i = 0; i + 2 < n; i++){
        int k = n - 1;
        for (int j = i + 2; j < n; j++){
            dp[k][j] = f(dp[k - 1][j], dp[k][j - 1], dp[k - 1][j - 1]);
            k--;
        }
    }
    */
    pair<ll, ll> ans = dp[n - q][p - 1];
    if (ans.first == ans.second){
        cout<<"1 1";
        return 0;
    }
    map<ll, int> cnt;
    for (int i = 2; i * i <= ans.first; i++){
        while (ans.first % i == 0){
            cnt[i]++;
            ans.first /= i;
        }
    }
    if (ans.first > 1){
        cnt[ans.first]++;
    }
    for (int i = 2; i * i <= ans.second; i++){
        while (ans.second % i == 0){
            cnt[i]--;
            ans.second /= i;
        }
    }
    if (ans.second > 1){
        cnt[ans.second]--;
    }
    for (auto i: cnt){
        cout<<i.first<<" "<<i.second<<endl;
    }
}