import sys

def query(x: int, y: int) -> bool:
    if x <= 0 or x > 100 or y <= 0 or y > 100:
        return False
    sys.stdout.flush()
    print('?', x, y)
    return input().strip() == 'inside'

def answer(result: bool):
    if result:
        print('! square')
    else:
        print('! rectangle')

def is_square(x1, y1, x2, y2):
    if x1 == x2 or y1 == y2:
        return False
    if query(x1, y1) == False and query(x2, y2) == False:
        return False
    if query(x1, y2) == False and query(x2, y1) == False:
        return False
    return True

x1, y1, x2, y2 = 1, 1, 100, 100
while True:
    x_middle = (x1 + x2) // 2
    y_middle = (y1 + y2) // 2
    if is_square(x1, y_middle, x2, y_middle) or is_square(x_middle, y1, x_middle, y2):
        answer(True)
        break
    if query(x_middle, y_middle):
        x1, y1, x2, y2 = x_middle, y_middle, x2, y2
    else:
        x1, y1, x2, y2 = x1, y1, x_middle, y_middle
else:
    answer(False)
