import sys

import math

# Function to check if a point is inside the painted area
def check_point(x, y):
    print("?", x, y)
    sys.stdout.flush()
    return input().strip() == "inside"

# Function to check if a rectangle is a square
def is_square(x1, y1, x2, y2):
    return (x2 - x1 + 1) == (y2 - y1 + 1)

# Initialize the corners of the painted area
x1, y1, x2, y2 = 1, 1, 100, 100

# Find the corners of the painted area
while True:
    mid_x = (x1 + x2) // 2
    mid_y = (y1 + y2) // 2

    if check_point(mid_x, y1):
        x2 = mid_x
    else:
        x1 = mid_x + 1

    if check_point(x1, mid_y):
        y2 = mid_y
    else:
        y1 = mid_y + 1
# Check if the painted area is a square
if is_square(x1, y1, x2, y2):
    print("! square")
else:
    print("! rectangle")
