import sys

import math

# Function to check if a point is inside the painted area
def check_point(x, y):
    print("?", x, y)
    sys.stdout.flush()
    return input() == "inside"

# Function to check if a rectangle is a square
def is_square(x1, y1, x2, y2):
    return (x2 - x1 + 1) == (y2 - y1 + 1)

# Initialize the corners of the painted area
x1, y1, x2, y2 = 1, 1, 100, 100

# Find the corners of the painted area
x1, y1, x2, y2 = 1, 1, 100, 100

# Find the corners of the painted area using binary search
while x1 < x2 or y1 < y2:
    mid_x = (x1 + x2) // 2
    mid_y = (y1 + y2) // 2

    if check_point(mid_x, mid_y):
        if check_point(mid_x - 1, mid_y):
            x2 = mid_x - 1

        if check_point(mid_x + 1, mid_y):
            x1 = mid_x + 1

        if check_point(mid_x, mid_y - 1):
            y2 = mid_y - 1

        if check_point(mid_x, mid_y + 1):
            y1 = mid_y + 1

    else: # Point is not inside the painted area so move it closer to the corner that's inside the painted area.

        if not check_point(mid_x - 1, mid_y): # If moving left doesn't work then move down instead.
            if not check_point(mid_x, mid_y - 1): # If moving down doesn't work then move right instead.
                if not check_point(mid_x + 1, mid_y): # If moving right doesn't work then move up instead.
                    if not check_point(mid_x, mid_y + 1): # If moving up doesn't work then we're done. The rectangle is empty.
                        break

                    else: # Move up by one unit. We know it's possible because we just checked that it works.
                        y1 = mid_y + 1

                else: # Move right by one unit. We know it's possible because we just checked that it works.
                    x1 = mid_x + 1

            else: # Move down by one unit. We know it's possible because we just checked that it works.
                y2 = mid_y - 1

        else: # Move left by one unit. We know it's possible because we just checked that it works.
            x2 = mid_x - 1

        continue # Skip the rest of this iteration and start the next iteration immediately.

    break # We're done finding the corners of the painted area. No need to do any more iterations of this loop.

    print("! rectangle")