import sys

# Function to check if a point is inside the painted area
def check_point(x, y):
    print("?", x, y)
    sys.stdout.flush()
    response = input().strip()
    return response == "inside"

# Function to check if a rectangle is a square
def is_square(x1, y1, x2, y2):
    return (x2 - x1) == (y2 - y1)

# Initialize the corners of the painted area
x1, y1, x2, y2 = 1, 1, 100, 100

# Find the corners of the painted area
while x1 < x2 or y1 < y2:
    if x1 < x2:
        mid = (x1 + x2) // 2

        if check_point(mid, y1):
            x2 = mid
        else:
            x1 = mid + 1

    if y1 < y2:
        mid = (y1 + y2) // 2

        if check_point(x1, mid):
            y2 = mid
        else:
            y1 = mid + 1

# Check if the painted area is a square
if is_square(x1, y1, x2, y2):
    print("! square")
else:
    print("! rectangle")
