import sys

# Function to check if a point is inside the painted area
def check_point(x, y):
    print("?", x, y)
    sys.stdout.flush()
    return input().strip() == "inside"

# Function to check if a rectangle is a square
def is_square(x1, y1, x2, y2):
    return (x2 - x1 + 1) == (y2 - y1 + 1)

# Initialize the corners of the painted area
x1, y1, x2, y2 = 1, 1, 100, 100

# Find the corners of the painted area
while x1 < x2 or y1 < y2:
    if x1 < x2:
        x_mid = (x1 + x2) // 2

        if check_point(x_mid, y1):
            x2 = x_mid
        else:
            x1 = x_mid + 1

    if y1 < y2:
        y_mid = (y1 + y2) // 2

        if check_point(x1, y_mid):
            y2 = y_mid
        else:
            y1 = y_mid + 1

# Check if the painted area is a square
if is_square(x1, y1, x2, y2):
    print("! square")
else:
    print("! rectangle")
