#include <bits/stdc++.h>
//#include "fct.cpp"

using namespace std;
typedef pair<int, int> pi;

bool query(int x, int y) {
    if (x <= 0 || x > 100 || y <= 0 || y > 100)
        return false;
    //return check(x, y);
    cout << "? " << x << " " << y << endl;
    cout.flush();
    string ans;
    cin >> ans;
    return (ans == "inside");
}

void answer(bool result) {
    if (result) {
        cout << "! square" << endl;
    } else {
        cout << "! rectangle" << endl;
    }
    cout.flush();
    exit(0);
}

void make_inside(bool a[6][6]){
    int s_min = 20;
    pi top_l = {-1, -1}, bot_r;
    for(int i = 1; i <= 4; ++i)
        for(int j = 1; j <= 4; ++j)
            if(a[i][j]){
                if(top_l.first == -1)
                    top_l = {i * 20, j * 20};
                bot_r = {i * 20, j * 20};
            }
    int r = top_l.second, l = top_l.second - 20;
    while(l != r){
        int m = (l + r) >> 1;
        if(query(top_l.first, m))
            r = m;
        else l = m + 1;
    }
    int lm = l;
    r = top_l.first, l = top_l.first - 20;
    while(l != r){
        int m = (l + r) >> 1;
        if(query(m, top_l.second))
            r = m;
        else l = m + 1;
    }
    int tm = l;
    l = bot_r.second, r = l + 21;
    while(l != r){
        int m = (l + r + 1) >> 1;
        if(query(bot_r.first, m))
            l = m;
        else r = m - 1;
    }
    int rm = l;
    int bm = tm + rm - lm;
    answer(query(bm, bot_r.second) && !query(bm + 1, bot_r.second));
}

void make_outside(bool a[6][6]){
    vector<bool> in;
    pair<int, int> sd;
    for(int i = 1; i <= 5; ++i)
        for(int j = 1; j <= 5; ++j)
            if(i == 5 || j == 5){
                in.push_back(query(i * 20, j * 20));
                if(in.back())
                    sd = {i * 20, j * 20};
            }
    int cnt = 0;
    for(auto c: in)
        cnt += c;
    if(cnt != 1)
        answer(0);
    int l, r;
    if(sd.first == 100){
        r = sd.second, l = sd.second - 20;
        while(l != r){
            int m = (l + r) >> 1;
            if(query(sd.first, m))
                r = m;
            else l = m + 1;
        }
        int lm = l, bm = 100, tm = 100 - 19, rm = l + 19;
        answer(query(bm, rm) && !query(bm, rm + 1));
        return;
    }
    r = sd.first, l = sd.first - 20;
    while(l != r){
        int m = (l + r) >> 1;
        if(query(m, sd.second))
            r = m;
        else l = m + 1;
    }
    int tm = l, rm = 100, lm = 100 - 19, bm = l + 19;
    answer(query(bm, sd.second) && !query(bm + 1, sd.second));
}

int main() {
    bool a[6][6], f = 0;
    for(int i = 1; i <= 4; ++i)
        for(int j = 1; j <= 4; ++j)
            a[i][j] = query(i * 20, j * 20), f |= a[i][j];
    if(f)
        make_inside(a);
    else make_outside(a);
}
