#include <bits/stdc++.h>
using namespace std;

int breakWith(long long& n, int d){
    if(n==0){
        return 0;
    }
    int power = 0;
    while(n%d==0){
        ++power;
        n/=d;
    }
    return 0;
}

map<int,int> breakUP(long long a){
    map<int,int> res;
    int pow2 = breakWith(a,2);
    if(pow2!=0){
        res[2]=pow2;
    }
    for(int i = 3;i*i<=a;i+=2){
        int powI = breakWith(a,i);
        if(powI!=0){
            res[i] =powI;
        }        
    }
    if(a!=1){
        res[a]++;
    }
    return res;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

	int n;
    cin>>n;
	int m[n],b[n-1];
    for(int i = 0;i<n;++i){
        cin>>m[i];
    }
    for(int i = 0;i<n-1;++i){
        cin>>b[i];
    }
    int p,q;
    cin>>p>>q;
    int k1 = m[0];
    int km = m[q-1];
    pair<int,int> a[n];
    a[0] = make_pair(1,1);
    for(int i = 0;i<n-1;++i){
        a[i+1] = make_pair(b[i],m[i]);
    }
    long long valUp = km;
    long long valDown = 1;
    for(int i = 0;i<p;++i){
        valUp*= a[i].first;
        valDown*= a[i].second;
    }
    for(int i = 0;i<q;++i){
        valUp*= a[i].second;
        valDown*= a[i].first;
    }
    map<int,int> Up = breakUP(valUp);
    map<int,int> Down = breakUP(valDown);
    for(auto it= Down.begin();it!=Down.end();++it){
        Up[(*it).first]-=(*it).second;
    }
    bool ALLZEROS = true;
    for(auto it = Up.begin();it!=Up.end();++it){
        if((*it).second!=0){
            cout<<(*it).first<<" "<<(*it).second<<endl;
            ALLZEROS=false;
        }
    }
    if(ALLZEROS){
        cout<<1<<" "<<1;
    }
}
