#include <bits/stdc++.h>
using namespace std;

void merg(list<pair<long long, long long>> &l1, list<pair<long long, long long>> &l2, long long c)
{
    auto itr1 = l1.begin();
    auto itr2 = l2.begin();
    for (;itr1!=l1.end() && itr2!=l2.end();++itr1) {
        if (itr1->first == itr2->first) {
            itr1->second+=c*(itr2->second);
            ++itr2;
        } else if (itr1->first > itr2->first) l1.insert(itr1, make_pair(itr2->first, c*(itr2->second))), ++itr2;
    }
    for (;itr2!=l2.end();++itr2) {
        l1.insert(l1.end(), make_pair(itr2->first, c*(itr2->second)));
    }
}

void m1(vector<vector<list<pair<long long, long long>>>> &ar, long long x, long long y)
{
    merg(ar[x][y], ar[x][y-1], 1);
    merg(ar[x][y], ar[x+1][y], 1);
    merg(ar[x][y], ar[x+1][y-1], -1);   
}

void m2(vector<vector<list<pair<long long, long long>>>> &ar, long long x, long long y)
{
    merg(ar[x][y], ar[x][y+1], 1);
    merg(ar[x][y], ar[x-1][y], 1);
    merg(ar[x][y], ar[x-1][y+1], -1);   
}

int  main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

	long long n;
	cin>>n;
    vector<vector<list<pair<long long, long long>>>> ar(n, vector<list<pair<long long, long long>>>(n));
    for (long long a=0;a<n;++a) {
        long long x;
        cin>>x;
        long long c = 0;
        while (x%2 == 0) {
            ++c;
            x/=2;
        }
        if (c!=0) ar[a][a].push_back(make_pair(2, c));
        for (long long i=3;i*i<=x;i+=2) {
            c = 0;
            while (x%i == 0) {
                ++c;
                x/=i;
            }
            if (c!=0) ar[a][a].push_back(make_pair(i, c));
        }
        if (x!=1) ar[a][a].push_back(make_pair(x, 1));
    }
    for (long long a=0;a<n-1;++a) {
        long long x;
        cin>>x;
        long long c = 0;
        while (x%2 == 0) {
            ++c;
            x/=2;
        }
        if (c!=0) ar[a+1][a].push_back(make_pair(2, c));
        for (long long i=3;i*i<=x;i+=2) {
            c = 0;
            while (x%i == 0) {
                ++c;
                x/=i;
            }
            if (c!=0) ar[a+1][a].push_back(make_pair(i, c));
        }
        if (x!=1) ar[a+1][a].push_back(make_pair(x, 1));
    }
    long long p, q;
    cin>>p>>q;
//    list<pair<long long, long long>> res;
    if (p<q) {
        for (long long i=p;i<q;++i) {
            for (long long x=p-1, y=i;y<q && x<n-1 && y>0;++x, ++y) m1(ar, x, y);
        }
    } else {
        for (long long i=q;i<p;++i) {
            long long x=i, y=q-1;
            if (abs(x-y)<2) continue;
            for (;x<p && y<n-1 && x>0;++x, ++y) m2(ar, x, y);
        }
    }
    for (auto i=ar[p-1][q-1].begin();i!=ar[p-1][q-1].end();) 
    {
        if (i->second == 0) ar[p-1][q-1].erase(i);
        else ++i;
    }
    if (ar[p-1][q-1].empty()) cout<<"1 1\n";
    else for (auto i=ar[p-1][q-1].begin();i!=ar[p-1][q-1].end();++i) cout<<i->first<<' '<<i->second<<'\n';
}
