#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
constexpr ll mod = 998244353;
unordered_map<int,int> A[1007]; // row
unordered_map<int,int> B[1007]; // col
inline void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    vector<int> b(n-1);
    vector<vector<pair<int,int>>> vta(n);
    vector<vector<pair<int,int>>> vtb(n-1);
    A[0][1] = 1;
    B[0][1] = 1;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        int x = a[i];
        for (int j = 2; j*j <= x; ++j) {
            int cnt = 0;
            while(x%j == 0) x/=j,cnt++;
            if(cnt) vta[i].push_back({j,cnt});
        }
        if(x) vta[i].push_back({x,1});
    }
    for (int i = 0; i < n-1; ++i) {
        cin >> b[i];
        int x = b[i];
        for (int j = 2; j*j <= x; ++j) {
            int cnt = 0;
            while(x%j == 0) x/=j,cnt++;
            if(cnt) vtb[i].push_back({j,cnt});
        }
        if(x) vtb[i].push_back({x,1});
    }
    int p,q;
    cin >> p >> q;
    for (int i = 0; i < n-1; ++i) {
        A[i+1] = A[i];
        for (auto e:vta[i]) {
            A[i+1][e.first]-=e.second;
        }
        for (auto e:vtb[i]) {
            A[i+1][e.first]+=e.second;
        }
    }
    for (int i = 0; i < n-1; ++i) {
        B[i+1] = B[i];
        for (auto e:vtb[i]) {
            B[i+1][e.first]-=e.second;
        }
        for (auto e:vta[i+1]) {
            B[i+1][e.first]+=e.second;
        }
    }
    unordered_map<int,int> ans;
    ans[1] = 1;
    for (auto e:vta[0]) {
        ans[e.first]+=e.second;
    }
    for (auto e:A[p-1]) {
        ans[e.first]+=e.second;
    }
    for (auto e:B[q-1]) {
        ans[e.first]+=e.second;
    }
    vector<pair<int,int>> ansv;
    for (auto e:ans){
        if(e.first == 1) continue;
        if(e.second == 0) continue;
        ansv.push_back(e);
    }
    if(ansv.size() == 0) ansv.push_back({1,1});
    sort(ansv.begin(),ansv.end());
    for (int i = 0; i < ansv.size(); ++i) {
        cout << ansv[i].first << " " << ansv[i].second << "\n";
    }

}
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) solve();
    return 0;
}