#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <math.h>
#include <queue>
#include <string>
#include <iomanip>
#include <set>
#include <cmath>
#include <unordered_map>

#define LF '\n'

using namespace std;
typedef long long int lli;

struct num
{
    unordered_map<lli, int> ch;
    unordered_map<lli, int> zn;
};

vector<num> g;
vector<num> v;
vector<lli> a;
vector<lli> b;

bool comp(pair<lli,lli> p1, pair<lli, lli> p2)
{
    return p1.first < p2.first;
}

void solve()
{
    lli n, p, q;
    cin >> n;
    g.resize(n+1);
    v.resize(n+1);
    a.resize(n+1);
    b.resize(n + 1);
    for (int i = 1; i <= n; i++)cin >> a[i];
    for (int i = 1; i < n; i++)cin >> b[i];
    cin >> p >> q;

    g[1].ch[1] = 1;
    g[1].zn[1] = 1;
    lli x = a[1];
    for (int i = 2; i <= sqrt(x); i++) {
        while (x % i == 0) {
            v[1].ch[i]++;
            x /= i;
        }
    }
    if (x > 1)v[1].ch[x]++;
    for (int i = 2; i <= n; i++) {
        g[i].zn = v[i - 1].ch;
        g[i].ch = v[i - 1].zn;
        x = b[i - 1];
        for (int j = 2; j <= sqrt(x); j++) {
            while (x % j == 0) {
                g[i].ch[j]++;
                x /= j;
            }
        }
        if (x > 1)g[i].ch[x]++;

        v[i].zn = g[i].ch;
        v[i].ch = g[i].zn;
        x = a[i];
        for (int j = 2; j <= sqrt(x); j++) {
            while (x % j == 0) {
                v[i].ch[j]++;
                x /= j;
            }
        }
        if (x > 1)v[i].ch[x]++;
    }
    unordered_map<lli, int> ans = g[p].ch;
    vector<pair<lli, lli>> res;
    for (auto to : v[q].ch) {
        ans[to.first] += to.second;
    }
    for (auto to : v[q].zn) ans[to.first] -= to.second;
    for (auto to : g[p].zn) ans[to.first] -= to.second;
    for (auto to : ans) {
        if (to.first != 1 && to.second != 0) {
            res.push_back(to);
        }
    }
    if (res.size() == 0) {
        cout << 1 << " " << 1;
        return;
    }
    sort(res.begin(), res.end(), comp);
    for (auto to : res) {
        cout << to.first << " " << to.second << LF;
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    solve();
}

