import sys


def query(x: int, y: int) -> bool:
    if x <= 0 or x > 100 or y <= 0 or y > 100:
        return False
    print('?', x, y)
    sys.stdout.flush()
    return input() == 'inside'


def answer(result: bool):
    if result:
        print('! square')
    else:
        print('! rectangle')
    sys.stdout.flush()


def GetBorder(x: int, y: int, direct: int, isX: bool):
    if isX:
        x1 = x
    else:
        x1 = y
    while 0 < x1 <= 100:
        if isX:
          while query(x1 + direct, y):
              x1 += direct
        else:
          while query(y, x1 + direct):
                x1 += direct
        return x1


step = 4
x = 1
y = 1
res = False
AX = 1
AY = 1

while x <= 100 and not res:
    while y <= 100 and not res:
        res = query(x, y)
        if res:
            AX = x
            AY = y
        y += step
    y = 1
    x += step

X1 = GetBorder(AX, AY, -1, True)
X2 = GetBorder(AX, AY, 1, True)
Y1 = GetBorder(AX, AY, -1, False)
Y2 = GetBorder(AX, AY, 1, False)

answer(abs(X1 - X2) == abs(Y1 - Y2))
