#include <bits/stdc++.h>
using namespace std;

using ll = long long;

ll n, m, q, k, x, y, a, b, c;

map< pair<ll, ll>, bool > mp;

ll randint(ll x, ll y) {
    return (rand() % (y - x + 1)) + x;
}

bool query(int x, int y) {
    if (mp.count({x, y})) {
        return mp[{x, y}];
    }
    if (x <= 0 || x > 100 || y <= 0 || y > 100)
        return false;
    cout << "? " << x << " " << y << endl;
    cout.flush();
    string ans;
    cin >> ans;
    // cout << ans << '\n';
    mp[{x, y}] = (ans == "inside");
    return (ans == "inside");
}

void answer(bool result) {
    if (result) {
        cout << "! square" << endl;
    } else {
        cout << "! rectangle" << endl;
    }
    cout.flush();
    exit(0);
}

int main() {
    srand(time(NULL));
    vector< pair<ll, ll> > v;
    for (int i = 20; i <= 100; i += 20) {
        for (int j = 20; j <= 100; j += 20) {
            v.push_back({i, j});
        }
    }
    // swap(v[0], v[21]);
    // swap(v[4], v[22]);
    // swap(v[20], v[23]);
    // for (int i = 0; i < v.size(); i++) {
    //     cout << i << ' ' << v[i].first << ' ' << v[i].second << '\n';
    // }
    for (int i = 0; i < v.size(); i++) {
        swap(v[i], v[randint(i, v.size() - 1)]);
    }
    x = -1;
    y = -1;
    for (int i = 0; i < v.size(); i++) {
        // cout << v[i].first << ' ' << v[i].second << '\n';
        if (query(v[i].first, v[i].second)) {
            x = v[i].first;
            y = v[i].second;
            break;
        }
    }
    if (x == -1) {
        answer(0);
    }
    ll l = x, r = 100;
    while (r > l) {
        ll mid = r - (r - l) / 2;
        if (query(mid, y)) {
            l = mid;
        }
        else {
            r = mid - 1;
        }
    }
    ll x2 = l;
    l = 0;
    r = x;
    while (r > l) {
        ll mid = (r + l) / 2;
        if (query(mid, y)) {
            r = mid;
        }
        else {
            l = mid + 1;
        }
    }
    ll x1 = l;
    l = y;
    r = 100;
    while (r > l) {
        ll mid = r - (r - l) / 2;
        if (query(x, mid)) {
            l = mid;
        }
        else {
            r = mid - 1;
        }
    }
    ll y2 = l;
    l = 0;
    r = y;
    while (r > l) {
        ll mid = (r + l) / 2;
        if (query(x, mid)) {
            r = mid;
        }
        else {
            l = mid + 1;
        }
    }
    ll y1 = l;
    // cout << x1 << ' ' << y1 << '\n';
    // cout << x2 << ' ' << y2 << '\n';
    answer(y2 - y1 == x2 - x1);
}